diff --git a/linux-2.6.37.6-antonio/ipc/stm.c b/linux-2.6.37.6-antonio/ipc/stm.c
new file mode 100644
index 0000000..b871c79
--- /dev/null
+++ b/linux-2.6.37.6-antonio/ipc/stm.c
@@ -0,0 +1,2803 @@
+/*
+ * This code is an adaption of TinyTM for the Linux Kernel
+ *
+ * Author(s):
+ *   Pascal Felber <pascal.felber@unine.ch> Copyright (c) 2007-2009.
+ *   Antonio Barbalace <antoniob@vt.edu> Copyright (c) 2011-2012
+ */
+
+/* TinyTM
+ *
+ * Transaction nesting is supported in a minimalist way (flat nesting):
+ * - When a transaction is started in the context of another
+ *   transaction, we simply increment a nesting counter but do not
+ *   actually start a new transaction.
+ * - The environment to be used for setjmp/longjmp is only returned when
+ *   no transaction is active so that it is not overwritten by nested
+ *   transactions. This allows for composability as the caller does not
+ *   need to know whether it executes inside another transaction.
+ * - The commit of a nested transaction simply decrements the nesting
+ *   counter. Only the commit of the top-level transaction will actually
+ *   carry through updates to shared memory.
+ * - An abort of a nested transaction will rollback the top-level
+ *   transaction and reset the nesting counter. The call to longjmp will
+ *   restart execution before the top-level transaction.
+ * Using nested transactions without setjmp/longjmp is not recommended
+ * as one would need to explicitly jump back outside of the top-level
+ * transaction upon abort of a nested transaction. This breaks
+ * composability.
+ */
+
+/*
+ * Reading from the previous version of locked addresses is implemented
+ * by peeking into the write set of the transaction that owns the
+ * lock. Each transaction has a unique identifier, updated even upon
+ * retry. A special "commit" bit of this identifier is set upon commit,
+ * right before writing the values from the redo log to shared memory. A
+ * transaction can read a locked address if the identifier of the owner
+ * does not change between before and after reading the value and
+ * version, and it does not have the commit bit set.
+ */
+
+
+
+#include <linux/errno.h>
+
+//#include <signal.h>
+//#include <stdio.h>
+
+//memory allocation must be handled by the slab linux allocator
+// we are going to use the kmem cache for stm_tx_t struct
+// and kmalloc/vmalloc for r_entry_t and w_entry_t because they use arrays
+// kmalloc have a 128kB limit do we have to switch to vmalloc?
+//#include <string.h>
+#include <linux/slab.h> // kmalloc
+//#include <linux/malloc.h> // kmem_cache DO NOT EXSIST
+#include <linux/vmalloc.h> // vmalloc
+
+//#include <pthread.h>
+
+//linux/sched.h now is not required but can be necessary
+//#include <sched.h>
+
+
+// original dependencies in TinySTM include/stm.h
+//#include "stm.h"
+#include <linux/stm.h> //new include directive (same as include/stm.h)
+//the following is the local stm.h include (naming convention to be rebuild?)
+#include "stm.h"
+
+#include <linux/stddef.h>
+
+//#include <assert.h>
+#define assert(a) BUG_ON(!(a))
+//#define assert(a) WARN_ON(a)
+
+#include "stm_atomic.h"
+
+
+#define COMPILE_TIME_ASSERT(pred)        switch (0) { case 0: case pred: ; }
+/* included in the linux kernel
+#if defined(__GNUC__) || defined(__INTEL_COMPILER)
+# define likely(x)                      __builtin_expect(!!(x), 1)
+# define unlikely(x)                    __builtin_expect(!!(x), 0)
+//#endif
+*/
+
+#include "stm_design.h"
+#include "stm_cm.h"
+#include "stm.h"
+
+static inline stm_tx_t * stm_get_tx(void);
+
+#include "stm_mod_stats.h"
+#include "stm_syscall.h"
+
+/* ################################################################### *
+ * THREAD-LOCAL
+ * ################################################################### */
+/*
+#ifdef TLS
+static __thread stm_tx_t* thread_tx = NULL;
+#else
+static pthread_key_t thread_tx;
+#endif
+*/
+//move to struct task_struct --> add transaction descriptor to
+
+static struct kmem_cache * stm_tx_cache = 0;
+
+ static inline stm_tx_t * stm_get_tx(void) {
+	 if ( !(current->thread_tx) )
+		 printk("%s: error tx desc is zero [pid %d]\n", __func__, current->pid);
+	 return current->thread_tx; }
+
+#if CM == CM_MODULAR
+#include "stm_cm_modular.h"
+#endif /* CM == CM_MODULAR */
+
+#ifdef LOCK_IDX_SWAP
+/*
+ * Compute index in lock table (swap bytes to avoid consecutive addresses to have neighboring locks).
+ */
+static inline unsigned int lock_idx_swap(unsigned int idx) {
+  return (idx & ~(unsigned int)0xFFFF) | ((idx & 0x00FF) << 8) | ((idx & 0xFF00) >> 8);
+}
+#endif /* LOCK_IDX_SWAP */
+
+#include "stm_quiesce.h"
+
+/*
+ * Reset clock and timestamps
+ */
+static inline void rollover_clock(void *arg)
+{
+  PRINT_DEBUG("==> rollover_clock()\n");
+
+  /* Reset clock */
+  CLOCK = 0;
+  /* Reset timestamps */
+  memset((void *)locks, 0, LOCK_ARRAY_SIZE * sizeof(stm_word_t));
+# ifdef EPOCH_GC
+  /* Reset GC */
+  gc_reset();
+# endif /* EPOCH_GC */
+}
+
+/*
+ * Check if stripe has been read previously.
+ */
+static inline r_entry_t *stm_has_read(stm_tx_t *tx, volatile stm_word_t *lock)
+{
+  r_entry_t *r;
+  int i;
+
+  PRINT_DEBUG("==> stm_has_read(%p[%lu-%lu],%p)\n", tx, (unsigned long)tx->start, (unsigned long)tx->end, lock);
+
+  /* Look for read */
+  r = tx->r_set.entries;
+  for (i = tx->r_set.nb_entries; i > 0; i--, r++) {
+    if (r->lock == lock) {
+      /* Return first match*/
+      return r;
+    }
+  }
+  return NULL;
+}
+
+#if DESIGN == WRITE_BACK_CTL
+/*
+ * Check if address has been written previously.
+ */
+static inline w_entry_t *stm_has_written(stm_tx_t *tx, volatile stm_word_t *addr)
+{
+  w_entry_t *w;
+  int i;
+# ifdef USE_BLOOM_FILTER
+  stm_word_t mask;
+# endif /* USE_BLOOM_FILTER */
+
+  PRINT_DEBUG("==> stm_has_written(%p[%lu-%lu],%p)\n", tx, (unsigned long)tx->start, (unsigned long)tx->end, addr);
+
+# ifdef USE_BLOOM_FILTER
+  mask = FILTER_BITS(addr);
+  if ((tx->w_set.bloom & mask) != mask)
+    return NULL;
+# endif /* USE_BLOOM_FILTER */
+
+  /* Look for write */
+  w = tx->w_set.entries;
+  for (i = tx->w_set.nb_entries; i > 0; i--, w++) {
+    if (w->addr == addr) {
+      return w;
+    }
+  }
+  return NULL;
+}
+#endif /* DESIGN == WRITE_BACK_CTL */
+
+/*
+ * (Re)allocate read set entries.
+ */
+static inline void stm_allocate_rs_entries(stm_tx_t *tx, int extend)
+{
+  PRINT_DEBUG("==> stm_allocate_rs_entries(%p[%lu-%lu],%d) r_set.size %d\n",
+		  tx, (unsigned long)tx->start, (unsigned long)tx->end, extend, tx->r_set.size);
+
+  if (extend) {
+	r_entry_t * entries;
+    /* Extend read set */
+    if ((entries = (r_entry_t *)vmalloc( tx->r_set.size * 2 * sizeof(r_entry_t))) == NULL) {
+      PERROR("%s: realloc read set\n", __func__);
+      BUG();
+//      exit(1); // TODO
+    }
+    // realloc duties
+    memcpy(entries, tx->r_set.entries, tx->r_set.size * sizeof(r_entry_t));
+    vfree(tx->r_set.entries);
+    tx->r_set.entries = entries;
+    tx->r_set.size *= 2;
+  } else {
+    /* Allocate read set */
+    if ((tx->r_set.entries = (r_entry_t *)vmalloc(tx->r_set.size * sizeof(r_entry_t))) == NULL) {
+      PERROR("%s: malloc read set\n", __func__);
+      BUG();
+//      exit(1); // TODO
+    }
+    memset(tx->r_set.entries, 0, (tx->r_set.size * sizeof(r_entry_t)));
+  }
+}
+
+/*
+ * (Re)allocate write set entries.
+ */
+static inline void stm_allocate_ws_entries(stm_tx_t *tx, int extend)
+{
+#if CM == CM_MODULAR || (defined(CONFLICT_TRACKING) && DESIGN != WRITE_THROUGH)
+  int i, first = (extend ? tx->w_set.size : 0);
+#endif /* CM == CM_MODULAR || (defined(CONFLICT_TRACKING) && DESIGN != WRITE_THROUGH) */
+
+  PRINT_DEBUG("==> stm_allocate_ws_entries(%p[%lu-%lu],%d) w_set.size %d\n",
+		  tx, (unsigned long)tx->start, (unsigned long)tx->end, extend, tx->r_set.size);
+
+  if (extend) {
+    /* Extend write set */
+#if DESIGN == WRITE_BACK_ETL
+    int j;
+    w_entry_t *ows, *nws;
+    /* Allocate new write set */
+    ows = tx->w_set.entries;
+    if ((nws = (w_entry_t *)vmalloc(tx->w_set.size * 2 * sizeof(w_entry_t))) == NULL) {
+      PERROR("malloc write set");
+      BUG();
+  //    exit(1);
+    }
+    /* Copy write set */
+    memcpy(nws, ows, tx->w_set.size * sizeof(w_entry_t));
+    /* Update pointers */
+    for (j = 0; j < tx->w_set.nb_entries; j++) {
+      if (ows[j].next != NULL)
+        nws[j].next = nws + (ows[j].next - ows);
+    }
+    /* Update locks */
+    for (j = 0; j < tx->w_set.nb_entries; j++) {
+      if (ows[j].lock == GET_LOCK(ows[j].addr)) 
+        ATOMIC_STORE_REL(ows[j].lock, LOCK_SET_ADDR_WRITE((stm_word_t)&nws[j]));
+    }
+    tx->w_set.entries = nws;
+    tx->w_set.size *= 2;
+# ifdef EPOCH_GC
+    gc_free(ows, tx->start);
+# else /* ! EPOCH_GC */
+    vfree(ows);
+# endif /* ! EPOCH_GC */
+#else /* DESIGN != WRITE_BACK_ETL */
+    w_entry_t * entries
+    if ((entries = (w_entry_t *)vmalloc(tx->w_set.size * 2 * sizeof(w_entry_t))) == NULL) {
+      PERROR("realloc write set");
+      exit(1);
+    }
+    // realloc duties
+    memcpy(entries, tx->w_set.entries, tx->w_set.size * sizeof(w_entry_t));
+    vfree(tx->w_set.entries);
+    tx->w_set.entries = entries;
+    tx->w_set.size *= 2;
+#endif /* DESIGN != WRITE_BACK_ETL */
+  } else {
+    /* Allocate write set */
+    if ((tx->w_set.entries = (w_entry_t *)vmalloc(tx->w_set.size * sizeof(w_entry_t))) == NULL) {
+      PERROR("malloc write set");
+      BUG();
+//      exit(1);
+    }
+    memset(tx->w_set.entries, 0, (tx->w_set.size * sizeof(w_entry_t)));
+  }
+
+#if CM == CM_MODULAR || (defined(CONFLICT_TRACKING) && DESIGN != WRITE_THROUGH)
+  /* Initialize fields */
+  for (i = first; i < tx->w_set.size; i++)
+    tx->w_set.entries[i].tx = tx;
+#endif /* CM == CM_MODULAR || (defined(CONFLICT_TRACKING) && DESIGN != WRITE_THROUGH) */
+}
+
+/*
+ * Validate read set (check if all read addresses are still valid now).
+ */
+static inline int stm_validate(stm_tx_t *tx)
+{
+  r_entry_t *r;
+  int i;
+  stm_word_t l;
+
+  PRINT_DEBUG("==> stm_validate(%p[%lu-%lu])\n", tx, (unsigned long)tx->start, (unsigned long)tx->end);
+
+  /* Validate reads */
+  r = tx->r_set.entries;
+  for (i = tx->r_set.nb_entries; i > 0; i--, r++) {
+    /* Read lock */
+    l = ATOMIC_LOAD(r->lock);
+    /* Unlocked and still the same version? */
+    if (LOCK_GET_OWNED(l)) {
+      /* Do we own the lock? */
+#if DESIGN == WRITE_THROUGH
+      if ((stm_tx_t *)LOCK_GET_ADDR(l) != tx)
+#else /* DESIGN != WRITE_THROUGH */
+      w_entry_t *w = (w_entry_t *)LOCK_GET_ADDR(l);
+      /* Simply check if address falls inside our write set (avoids non-faulting load) */
+      if (!(tx->w_set.entries <= w && w < tx->w_set.entries + tx->w_set.nb_entries))
+#endif /* DESIGN != WRITE_THROUGH */
+      {
+        /* Locked by another transaction: cannot validate */
+#ifdef CONFLICT_TRACKING
+        if (conflict_cb != NULL && l != LOCK_UNIT) {
+          /* Call conflict callback */
+# if DESIGN == WRITE_THROUGH
+          stm_tx_t *other = (stm_tx_t *)LOCK_GET_ADDR(l);
+# else /* DESIGN != WRITE_THROUGH */
+          stm_tx_t *other = ((w_entry_t *)LOCK_GET_ADDR(l))->tx;
+# endif /* DESIGN != WRITE_THROUGH */
+          conflict_cb(tx, other);
+        }
+#endif /* CONFLICT_TRACKING */
+        return 0;
+      }
+      /* We own the lock: OK */
+#if DESIGN == WRITE_BACK_CTL
+      if (w->version != r->version) {
+        /* Other version: cannot validate */
+        return 0;
+      }
+#endif /* DESIGN == WRITE_BACK_CTL */
+    } else {
+      if (LOCK_GET_TIMESTAMP(l) != r->version) {
+        /* Other version: cannot validate */
+        return 0;
+      }
+      /* Same version: OK */
+    }
+  }
+  return 1;
+}
+
+/*
+ * Extend snapshot range.
+ */
+static inline int stm_extend(stm_tx_t *tx)
+{
+  stm_word_t now;
+
+  PRINT_DEBUG("==> stm_extend(%p[%lu-%lu])\n", tx, (unsigned long)tx->start, (unsigned long)tx->end);
+
+  /* Get current time */
+  now = GET_CLOCK;
+  if (now >= VERSION_MAX) {
+    /* Clock overflow */
+    return 0;
+  }
+  /* Try to validate read set */
+  if (stm_validate(tx)) {
+    /* It works: we can extend until now */
+    tx->end = now;
+    return 1;
+  }
+  return 0;
+}
+
+#if CM == CM_MODULAR
+/*
+ * Kill other transaction.
+ */
+static inline int stm_kill(stm_tx_t *tx, stm_tx_t *other, stm_word_t status)
+{
+  stm_word_t c, t;
+
+  PRINT_DEBUG("==> stm_kill(%p[%lu-%lu],%p,s=%d)\n", tx, (unsigned long)tx->start, (unsigned long)tx->end, other, status);
+
+# ifdef CONFLICT_TRACKING
+  if (conflict_cb != NULL)
+    conflict_cb(tx, other);
+# endif /* CONFLICT_TRACKING */
+
+# ifdef IRREVOCABLE_ENABLED
+  if (GET_STATUS(status) == TX_IRREVOCABLE)
+    return 0;
+# endif /* IRREVOCABLE_ENABLED */
+  if (GET_STATUS(status) == TX_ABORTED || GET_STATUS(status) == TX_COMMITTED || GET_STATUS(status) == TX_KILLED)
+    return 0;
+  if (GET_STATUS(status) == TX_ABORTING || GET_STATUS(status) == TX_COMMITTING) {
+    /* Transaction is already aborting or committing: wait */
+    while (other->status == status)
+      ;
+    return 0;
+  }
+  assert(IS_ACTIVE(status));
+  /* Set status to KILLED */
+  //if (ATOMIC_CAS_FULL(&other->status, status, status + (TX_KILLED - TX_ACTIVE)) == 0) {
+  if (ATOMIC_CAS_FULL(&other->status, status, status + (TX_KILLED - TX_ACTIVE)) != status) {
+    /* Transaction is committing/aborting (or has committed/aborted) */
+    c = GET_STATUS_COUNTER(status);
+    do {
+      t = other->status;
+# ifdef IRREVOCABLE_ENABLED
+      if (GET_STATUS(t) == TX_IRREVOCABLE)
+        return 0;
+# endif /* IRREVOCABLE_ENABLED */
+    } while (GET_STATUS(t) != TX_ABORTED && GET_STATUS(t) != TX_COMMITTED && GET_STATUS(t) != TX_KILLED && GET_STATUS_COUNTER(t) == c);
+    return 0;
+  }
+  /* We have killed the transaction: we can steal the lock */
+  return 1;
+}
+
+/*
+ * Drop locks after having been killed.
+ */
+static inline void stm_drop(stm_tx_t *tx)
+{
+  w_entry_t *w;
+  stm_word_t l;
+  int i;
+
+  PRINT_DEBUG("==> stm_drop(%p[%lu-%lu])\n", tx, (unsigned long)tx->start, (unsigned long)tx->end);
+
+  /* Drop locks */
+  i = tx->w_set.nb_entries;
+  if (i > 0) {
+    w = tx->w_set.entries;
+    for (; i > 0; i--, w++) {
+      l = ATOMIC_LOAD_ACQ(w->lock);
+      if (LOCK_GET_OWNED(l) && (w_entry_t *)LOCK_GET_ADDR(l) == w) {
+        /* Drop using CAS */
+        ATOMIC_CAS_FULL(w->lock, l, LOCK_SET_TIMESTAMP(w->version));
+        /* If CAS fail, lock has been stolen or already released in case a lock covers multiple addresses */
+      }
+    }
+    /* We need to reallocate the write set to avoid an ABA problem (the
+     * transaction could reuse the same entry after having been killed
+     * and restarted, and another slow transaction could steal the lock
+     * using CAS without noticing the restart) */
+    gc_free(tx->w_set.entries, tx->start);
+    stm_allocate_ws_entries(tx, 0);
+  }
+}
+#endif /* CM == CM_MODULAR */
+
+/*
+ * Initialize the transaction descriptor before start or restart.
+ */
+// functions called in stm_prepare:
+// stm_quiesce_barrier, stm_set_irrevocable, stm_check_quiesce
+static inline void stm_prepare(stm_tx_t *tx)
+{
+#if CM == CM_MODULAR
+  if (tx->visible_reads >= vr_threshold && vr_threshold >= 0) {
+    /* Use visible read */
+    if (tx->attr != NULL && tx->attr->read_only) {
+      /* Update attributes to inform the caller */
+      tx->attr->read_only = 0;
+    }
+    tx->ro = 0;
+  }
+#endif /* CM == CM_MODULAR */
+ start:
+  /* Start timestamp */
+  tx->start = tx->end = GET_CLOCK; /* OPT: Could be delayed until first read/write */
+
+  /* Allow extensions */
+  tx->can_extend = 1;
+  if (tx->start >= VERSION_MAX) {
+    /* Block all transactions and reset clock */
+    stm_quiesce_barrier(tx, rollover_clock, NULL);
+    goto start;
+  }
+#if CM == CM_MODULAR
+  if (tx->retries == 0)
+    tx->timestamp = tx->start;
+#endif /* CM == CM_MODULAR */
+  /* Read/write set */
+#if DESIGN == WRITE_BACK_ETL
+  tx->w_set.has_writes = 0;
+#elif DESIGN == WRITE_BACK_CTL
+  tx->w_set.nb_acquired = 0;
+# ifdef USE_BLOOM_FILTER
+  tx->w_set.bloom = 0;
+# endif /* USE_BLOOM_FILTER */
+#endif /* DESIGN == WRITE_BACK_CTL */
+  tx->w_set.nb_entries = 0;
+  tx->r_set.nb_entries = 0;
+
+#ifdef STM_PREEMPT_BONUS
+  tx->bonus = 0;
+#endif /* STM_PREEMPT_AVOIDANCE */
+
+#ifdef EPOCH_GC
+  gc_set_epoch(tx->start);
+#endif /* EPOCH_GC */
+
+#ifdef IRREVOCABLE_ENABLED
+  if (tx->irrevocable != 0) {
+    assert(!IS_ACTIVE(tx->status));
+    stm_set_irrevocable(TXARGS -1);
+    UPDATE_STATUS(tx->status, TX_IRREVOCABLE);
+  } else
+    UPDATE_STATUS(tx->status, TX_ACTIVE);
+#else /* ! IRREVOCABLE_ENABLED */
+  /* Set status */
+  UPDATE_STATUS(tx->status, TX_ACTIVE);
+#endif /* ! IRREVOCABLE_ENABLED */
+
+  stm_check_quiesce(tx);
+}
+
+// this is experimental, a trace_printk can be used instead
+void trace_stm_rollback(unsigned long, int, int);
+
+/*
+ * Rollback transaction.
+ */
+//tx is the current transaction descriptor on which the thread is in!
+//rollback means ABORT the current transaction and restructure everything as was before
+//WAS static inline void
+static int stm_rollback(stm_tx_t *tx, int reason)
+{
+  w_entry_t *w;
+#if DESIGN != WRITE_BACK_CTL
+  int i;
+#endif /* DESIGN != WRITE_BACK_CTL */
+#if DESIGN == WRITE_THROUGH || CM == CM_MODULAR
+  stm_word_t t;
+#endif /* DESIGN == WRITE_THROUGH || CM == CM_MODULAR */
+#if CM == CM_BACKOFF
+  unsigned long wait;
+  volatile int j;
+#endif /* CM == CM_BACKOFF */
+
+  PRINT_DEBUG("==> stm_rollback(%p[%lu-%lu]) reason %d\n",
+		  tx, (unsigned long)tx->start, (unsigned long)tx->end, reason);
+
+  assert(IS_ACTIVE(tx->status));
+#if CM == CM_MODULAR
+  /* Set status to ABORTING */
+  t = tx->status;
+  if (GET_STATUS(t) == TX_KILLED || (GET_STATUS(t) == TX_ACTIVE
+		  && ATOMIC_CAS_FULL(&tx->status, t, t + (TX_ABORTING - TX_ACTIVE)) != t)) {
+	  //&& ATOMIC_CAS_FULL(&tx->status, t, t + (TX_ABORTING - TX_ACTIVE)) == 0)) {/
+    /* We have been killed */
+    assert(GET_STATUS(tx->status) == TX_KILLED);
+# ifdef INTERNAL_STATS
+    tx->aborts_killed++;
+# endif /* INTERNAL_STATS */
+    /* Release locks */
+    stm_drop(tx);
+    goto dropped;
+  }
+#endif /* CM == CM_MODULAR */
+
+#if DESIGN == WRITE_THROUGH
+  t = 0;
+  /* Undo writes and drop locks (traverse in reverse order) */
+  w = tx->w_set.entries + tx->w_set.nb_entries;
+  while (w != tx->w_set.entries) {
+    w--;
+    if (w->mask != 0)
+      ATOMIC_STORE(w->addr, w->value);
+    if (w->no_drop)
+      continue;
+    /* Incarnation numbers allow readers to detect dirty reads */
+    i = LOCK_GET_INCARNATION(w->version) + 1;
+    if (i > INCARNATION_MAX) {
+      /* Simple approach: write new version (might trigger unnecessary aborts) */
+      if (t == 0) {
+        /* Get new version (may exceed VERSION_MAX by up to MAX_THREADS) */
+        t = FETCH_INC_CLOCK;
+      }
+      ATOMIC_STORE_REL(w->lock, LOCK_SET_TIMESTAMP(t));
+    } else {
+      /* Use new incarnation number */
+      ATOMIC_STORE_REL(w->lock, LOCK_UPD_INCARNATION(w->version, i));
+    }
+  }
+#elif DESIGN == WRITE_BACK_ETL
+  /* Drop locks */
+  i = tx->w_set.nb_entries;
+  if (i > 0) {
+    w = tx->w_set.entries;
+    for (; i > 0; i--, w++) {
+      if (w->next == NULL) {
+        /* Only drop lock for last covered address in write set */
+#  if CM == CM_DELAY && defined(WAIT_COND)
+    	  mutex_lock(&(locks_mutex[LOCK_IDX(w->addr)]));
+    	  	  *(w->lock) = LOCK_SET_TIMESTAMP(w->version);
+    	  	  cond_broadcast(&(locks_cond[LOCK_IDX(w->addr)]));
+    	  mutex_unlock(&(locks_mutex[LOCK_IDX(w->addr)]));
+#  else /* CM != CM_DELAY && defined(WAIT_COND) */
+        ATOMIC_STORE(w->lock, LOCK_SET_TIMESTAMP(w->version));
+#  endif /* CM != CM_DELAY && defined(WAIT_COND) */
+      }
+    }
+    /* Make sure that all lock releases become visible */
+    ATOMIC_MB_WRITE;
+  }
+#else /* DESIGN == WRITE_BACK_CTL */
+  if (tx->w_set.nb_acquired > 0) {
+    w = tx->w_set.entries + tx->w_set.nb_entries;
+    do {
+      w--;
+      if (!w->no_drop) {
+        if (--tx->w_set.nb_acquired == 0) {
+          /* Make sure that all lock releases become visible to other threads */
+          ATOMIC_STORE_REL(w->lock, LOCK_SET_TIMESTAMP(w->version));
+        } else {
+          ATOMIC_STORE(w->lock, LOCK_SET_TIMESTAMP(w->version));
+        }
+      }
+    } while (tx->w_set.nb_acquired > 0);
+  }
+#endif /* DESIGN == WRITE_BACK_CTL */
+
+#if CM == CM_MODULAR
+ dropped:
+#endif /* CM == CM_MODULAR */
+
+#if CM == CM_MODULAR || defined(INTERNAL_STATS)
+  tx->retries++;
+#endif /* CM == CM_MODULAR || defined(INTERNAL_STATS) */
+#ifdef INTERNAL_STATS
+  tx->aborts++;
+  if (tx->retries == 1)
+    tx->aborts_1++;
+  else if (tx->retries == 2)
+    tx->aborts_2++;
+  if (tx->max_retries < tx->retries)
+    tx->max_retries = tx->retries;
+#endif /* INTERNAL_STATS */
+
+  /* Callbacks */
+/*  if (nb_abort_cb != 0) {
+    int cb;
+    for (cb = 0; cb < nb_abort_cb; cb++)
+      abort_cb[cb].f(TXARGS abort_cb[cb].arg);
+  }
+*/
+  mod_stats_on_abort();
+
+  /* Set status to ABORTED */
+  SET_STATUS(tx->status, TX_ABORTED);
+
+  /* Reset nesting level */
+  tx->nesting = 1; // why not resetted to 0?!?!
+
+#if CM == CM_BACKOFF
+  /* Simple RNG (good enough for backoff) */
+  tx->seed ^= (tx->seed << 17);
+  tx->seed ^= (tx->seed >> 13);
+  tx->seed ^= (tx->seed << 5);
+  wait = tx->seed % tx->backoff;
+  for (j = 0; j < wait; j++) {
+    /* Do nothing */
+  }
+  if (tx->backoff < MAX_BACKOFF)
+    tx->backoff <<= 1;
+#endif /* CM == CM_BACKOFF */
+
+#if CM == CM_DELAY || CM == CM_MODULAR
+  /* Wait until contented lock is free */
+  if (tx->c_lock != NULL) {
+# ifdef WAIT_COND
+	  int lidx = (tx->c_lock - locks);
+	  mutex_lock(&locks_mutex[lidx]);
+	  while (LOCK_GET_OWNED(ATOMIC_LOAD(tx->c_lock)))
+		  cond_wait (&locks_cond[lidx], &locks_mutex[lidx]);
+	  mutex_unlock(&locks_mutex[lidx]);
+# else /* WAIT_COND */
+#if defined (STM_PREEMPT_BONUS) && !defined(WAIT_YIELD)
+  /* if the current transaction receives at least one bonus time slice call schedule */
+  if (tx->bonus)
+	  yield();
+#endif /* !STM_PREEMPTION_AVOIDANCE */
+    /* Busy waiting (yielding is expensive) */
+    while (LOCK_GET_OWNED(ATOMIC_LOAD(tx->c_lock))) {
+#  ifdef WAIT_YIELD
+      yield();
+#  endif /* WAIT_YIELD */
+    }
+# endif /* WAIT_COND */
+    tx->c_lock = NULL;
+  }
+#endif /* CM == CM_DELAY || CM == CM_MODULAR */
+
+  /* Reset field to restart transaction */
+  stm_prepare(tx); //set the status to ACTIVE
+
+  trace_stm_rollback(tx, reason, !tx->attr.no_retry);
+  /* Jump back to transaction start */
+//  if (tx->attr == NULL || !tx->attr->no_retry)
+  if (!tx->attr.no_retry)
+	 //siglongjmp(tx->env, reason);
+	  return ROLLBACK_REQUESTED;
+  else
+      return ROLLBACK_NO_RETRY;
+
+}
+
+/*
+ * Load a word-sized value (invisible read).
+ */
+//WAS static inline stm_word_t stm_read_invisible(stm_tx_t *tx, volatile stm_word_t *addr)
+static int stm_read_invisible(stm_tx_t *tx, volatile stm_word_t *addr, stm_word_t *ptrvalue)
+{
+  volatile stm_word_t *lock;
+  stm_word_t l, l2, value, version;
+  r_entry_t *r;
+#if DESIGN == WRITE_BACK_ETL
+  w_entry_t *w;
+#endif /* DESIGN == WRITE_BACK_ETL */
+#if DESIGN == WRITE_BACK_CTL
+  w_entry_t *written = NULL;
+#endif /* DESIGN == WRITE_BACK_CTL */
+#if CM == CM_MODULAR
+  stm_word_t t;
+  int decision;
+#endif /* CM == CM_MODULAR */
+
+  PRINT_DEBUG2("==> stm_read_invisible(t=%p[%lu-%lu],a=%p)\n", tx, (unsigned long)tx->start, (unsigned long)tx->end, addr);
+
+#if CM != CM_MODULAR
+  assert(IS_ACTIVE(tx->status));
+#endif /* CM != CM_MODULAR */
+
+#if DESIGN == WRITE_BACK_CTL
+  /* Did we previously write the same address? */
+  written = stm_has_written(tx, addr);
+  if (written != NULL) {
+    /* Yes: get value from write set if possible */
+    if (written->mask == ~(stm_word_t)0) {
+      value = written->value;
+      /* No need to add to read set */
+      // return value;
+      *ptrvalue = value;
+      return SUCCESS;
+    }
+  }
+#endif /* DESIGN == WRITE_BACK_CTL */
+
+  /* Get reference to lock */
+  lock = GET_LOCK(addr);
+
+  /* Note: we could check for duplicate reads and get value from read set */
+
+  /* Read lock, value, lock */
+ restart:
+#if CM == CM_DELAY && defined(WAIT_COND)
+  mutex_lock(&(locks_mutex[LOCK_IDX(addr)]));
+ 	  l = *lock;
+  mutex_unlock(&(locks_mutex[LOCK_IDX(addr)]));
+#else /* CM != CM_DELAY && defined(WAIT_COND) */
+  l = ATOMIC_LOAD_ACQ(lock);
+#endif /* CM != CM_DELAY && defined(WAIT_COND) */
+ restart_no_load:
+  if (LOCK_GET_WRITE(l)) {
+    /* Locked */
+    if (l == LOCK_UNIT) {
+      /* Data modified by a unit store: should not last long => retry */
+      goto restart;
+    }
+    /* Do we own the lock? */
+#if DESIGN == WRITE_THROUGH
+    if (tx == (stm_tx_t *)LOCK_GET_ADDR(l)) {
+      /* Yes: we have a version locked by us that was valid at write time */
+      value = ATOMIC_LOAD(addr);
+      /* No need to add to read set (will remain valid) */
+      //return value;
+      *ptrvalue = value;
+      return SUCCESS;
+    }
+#elif DESIGN == WRITE_BACK_ETL
+    w = (w_entry_t *)LOCK_GET_ADDR(l);
+    /* Simply check if address falls inside our write set (avoids non-faulting load) */
+    if (tx->w_set.entries <= w && w < tx->w_set.entries + tx->w_set.nb_entries) {
+      /* Yes: did we previously write the same address? */
+      while (1) {
+        if (addr == w->addr) {
+          /* Yes: get value from write set (or from memory if mask was empty) */
+          if (w->mask == 0) {
+              /* CHECK USER SPACE ADDRESS ACCESS */
+              if (!access_ok(VERIFY_READ, addr, sizeof(value)))
+            	  printk("%s: 1 access_ok addr %p size %d error [%d]\n",__func__, addr, sizeof(value), current->pid);
+              value = ATOMIC_LOAD(addr);
+          } else
+        	  value = w->value;
+          break;
+        }
+        if (w->next == NULL) {
+          /* No: get value from memory */
+          /* CHECK USER SPACE ADDRESS ACCESS */
+          if (!access_ok(VERIFY_READ, addr, sizeof(value)))
+        	  printk("%s: 2 access_ok addr %p size %d error [%d]\n",__func__, addr, sizeof(value), current->pid);
+          value = ATOMIC_LOAD(addr);
+# if CM == CM_MODULAR
+          if (GET_STATUS(tx->status) == TX_KILLED) {
+            *ptrvalue = 0;
+            return stm_rollback(tx, STM_ABORT_KILLED);
+          }
+# endif
+          break;
+        }
+        w = w->next;
+      }
+      /* No need to add to read set (will remain valid) */
+      //return value;
+      *ptrvalue = value;
+      return SUCCESS;
+    }
+#endif /* DESIGN == WRITE_BACK_ETL */
+#if DESIGN == WRITE_BACK_CTL
+    /* Spin while locked (should not last long) */
+    goto restart;
+#else /* DESIGN != WRITE_BACK_CTL */
+    /* Conflict: CM kicks in (we could also check for duplicate reads and get value from read set) */
+# if CM != CM_MODULAR && defined(IRREVOCABLE_ENABLED)
+    if(tx->irrevocable) {
+      /* Spin while locked */
+      goto restart;
+    }
+# endif /* CM != CM_MODULAR && defined(IRREVOCABLE_ENABLED) */
+# if CM == CM_MODULAR
+    t = w->tx->status;
+    l2 = ATOMIC_LOAD_ACQ(lock);
+    if (l != l2) {
+      l = l2;
+      goto restart_no_load;
+    }
+    if (t != w->tx->status) {
+      /* Transaction status has changed: restart the whole procedure */
+      goto restart;
+    }
+#  ifdef READ_LOCKED_DATA
+#   ifdef IRREVOCABLE_ENABLED
+    if (IS_ACTIVE(t) && !tx->irrevocable)
+#   else /* ! IRREVOCABLE_ENABLED */
+    if (GET_STATUS(t) == TX_ACTIVE)
+#   endif /* ! IRREVOCABLE_ENABLED */
+    {
+      /* Read old version */
+      version = ATOMIC_LOAD(&w->version);
+      /* Read data */
+      value = ATOMIC_LOAD(addr);
+      /* Check that data has not been written */
+      if (t != w->tx->status) {
+        /* Data concurrently modified: a new version might be available => retry */
+        goto restart;
+      }
+      if (version >= tx->start && (version <= tx->end || (!tx->ro && tx->can_extend && stm_extend(tx)))) {
+      /* Success */
+#  ifdef INTERNAL_STATS
+        tx->locked_reads_ok++;
+#  endif /* INTERNAL_STATS */
+        goto add_to_read_set;
+      }
+      /* Invalid version: not much we can do => fail */
+#  ifdef INTERNAL_STATS
+      tx->locked_reads_failed++;
+#  endif /* INTERNAL_STATS */
+    }
+#  endif /* READ_LOCKED_DATA */
+    if (GET_STATUS(t) == TX_KILLED) {
+      /* We can safely steal lock */
+      decision = KILL_OTHER;
+    } else {
+      decision =
+#  ifdef IRREVOCABLE_ENABLED
+        GET_STATUS(tx->status) == TX_IRREVOCABLE ? KILL_OTHER :
+        GET_STATUS(t) == TX_IRREVOCABLE ? KILL_SELF :
+#  endif /* IRREVOCABLE_ENABLED */
+        GET_STATUS(tx->status) == TX_KILLED ? KILL_SELF :
+        (contention_manager != NULL ? contention_manager(tx, w->tx, WR_CONFLICT) : KILL_SELF);
+      if (decision == KILL_OTHER) {
+        /* Kill other */
+        if (!stm_kill(tx, w->tx, t)) {
+          /* Transaction may have committed or aborted: retry */
+          goto restart;
+        }
+      }
+    }
+    if (decision == KILL_OTHER) {
+      /* Steal lock */
+      l2 = LOCK_SET_TIMESTAMP(w->version);
+      //if (ATOMIC_CAS_FULL(lock, l, l2) == 0)
+      if (ATOMIC_CAS_FULL(lock, l, l2) != l)
+        goto restart;
+      l = l2;
+      goto restart_no_load;
+    }
+    /* Kill self */
+    if ((decision & DELAY_RESTART) != 0)
+      tx->c_lock = lock;
+# elif CM == CM_DELAY
+    tx->c_lock = lock;
+# endif /* CM == CM_DELAY */
+    /* Abort */
+# ifdef INTERNAL_STATS
+    tx->aborts_locked_read++;
+# endif /* INTERNAL_STATS */
+# ifdef CONFLICT_TRACKING
+    if (conflict_cb != NULL && l != LOCK_UNIT) {
+      /* Call conflict callback */
+#  if DESIGN == WRITE_THROUGH
+      stm_tx_t *other = (stm_tx_t *)LOCK_GET_ADDR(l);
+#  else /* DESIGN != WRITE_THROUGH */
+      stm_tx_t *other = ((w_entry_t *)LOCK_GET_ADDR(l))->tx;
+#  endif /* DESIGN != WRITE_THROUGH */
+      conflict_cb(tx, other);
+    }
+# endif /* CONFLICT_TRACKING */
+    *ptrvalue = 0;
+    return stm_rollback(tx, STM_ABORT_RW_CONFLICT);
+    //return 0;
+#endif /* DESIGN != WRITE_BACK_CTL */
+  } else {
+    /* Not locked */
+    value = ATOMIC_LOAD_ACQ(addr);
+#if CM == CM_DELAY && defined(WAIT_COND)
+    mutex_lock(&(locks_mutex[LOCK_IDX(addr)]));
+   	  l2 = *lock;
+    mutex_unlock(&(locks_mutex[LOCK_IDX(addr)]));
+#else /* CM != CM_DELAY && defined(WAIT_COND) */
+    l2 = ATOMIC_LOAD_ACQ(lock);
+#endif /*  CM != CM_DELAY && defined(WAIT_COND) */
+    if (l != l2) {
+      l = l2;
+      goto restart_no_load;
+    }
+#ifdef IRREVOCABLE_ENABLED
+    /* In irrevocable mode, no need check timestamp nor add entry to read set */
+    if (tx->irrevocable)
+      return value;
+#endif /* IRREVOCABLE_ENABLED */
+    /* Check timestamp */
+#if CM == CM_MODULAR
+    if (LOCK_GET_READ(l))
+      version = ((w_entry_t *)LOCK_GET_ADDR(l))->version;
+    else
+      version = LOCK_GET_TIMESTAMP(l);
+#else /* CM != CM_MODULAR */
+    version = LOCK_GET_TIMESTAMP(l);
+#endif /* CM != CM_MODULAR */
+    PRINT_DEBUG3("version %d > tx->end %d tx->no_retry %d tx->ro %d tx->can_extend %d addr %p l %p lock %p\n",
+    		version, tx->end, tx->attr.no_retry, tx->ro, tx->can_extend, addr, l, lock);
+    /* Valid version? */
+    if (version > tx->end) {
+#ifdef IRREVOCABLE_ENABLED
+      assert(!tx->irrevocable);
+#endif /* IRREVOCABLE_ENABLED */
+      /* No: try to extend first (except for read-only transactions: no read set) */
+      if (tx->ro || !tx->can_extend || !stm_extend(tx)) {
+        /* Not much we can do: abort */
+#if CM == CM_MODULAR
+        /* Abort caused by invisible reads */
+        tx->visible_reads++;
+#endif /* CM == CM_MODULAR */
+#ifdef INTERNAL_STATS
+        tx->aborts_validate_read++;
+#endif /* INTERNAL_STATS */
+        *ptrvalue = value;
+        return stm_rollback(tx, STM_ABORT_VAL_READ);
+        //return 0;
+      }
+      /* Verify that version has not been overwritten (read value has not
+       * yet been added to read set and may have not been checked during
+       * extend) */
+#if CM == CM_DELAY && defined(WAIT_COND)
+      mutex_lock(&(locks_mutex[LOCK_IDX(addr)]));
+      	  l = *lock;
+      mutex_unlock(&(locks_mutex[LOCK_IDX(addr)]));
+#else /* CM == CM_DELAY && defined(WAIT_COND) */
+      l = ATOMIC_LOAD_ACQ(lock);
+#endif /* CM == CM_DELAY && defined(WAIT_COND) */
+      if (l != l2) {
+        l = l2;
+        goto restart_no_load;
+      }
+      /* Worked: we now have a good version (version <= tx->end) */
+    }
+#if CM == CM_MODULAR
+    /* Check if killed (necessary to avoid possible race on read-after-write) */
+    if (GET_STATUS(tx->status) == TX_KILLED) {
+      *ptrvalue = value;
+      return stm_rollback(tx, STM_ABORT_KILLED);
+      //return 0;
+    }
+#endif /* CM == CM_MODULAR */
+  }
+  /* We have a good version: add to read set (update transactions) and return value */
+
+#if DESIGN == WRITE_BACK_CTL
+  /* Did we previously write the same address? */
+  if (written != NULL) {
+    value = (value & ~written->mask) | (written->value & written->mask);
+    /* Must still add to read set */
+  }
+#endif /* DESIGN == WRITE_BACK_CTL */
+#ifdef READ_LOCKED_DATA
+ add_to_read_set:
+#endif /* READ_LOCKED_DATA */
+  if (!tx->ro) {
+#ifdef NO_DUPLICATES_IN_RW_SETS
+    if (stm_has_read(tx, lock) != NULL)
+      //return value;
+      *ptrvalue = value;
+      return SUCCESS;
+#endif /* NO_DUPLICATES_IN_RW_SETS */
+    /* Add address and version to read set */
+    if (tx->r_set.nb_entries == tx->r_set.size)
+      stm_allocate_rs_entries(tx, 1);
+    r = &tx->r_set.entries[tx->r_set.nb_entries++];
+    r->version = version;
+    r->lock = lock;
+  }
+  //return value;
+  *ptrvalue = value;
+  return SUCCESS;
+}
+
+#if CM == CM_MODULAR
+/*
+ * Load a word-sized value (visible read).
+ */
+// WAS static inline stm_word_t stm_read_visible(stm_tx_t *tx, volatile stm_word_t *addr)
+static int stm_read_visible(stm_tx_t *tx, volatile stm_word_t *addr, stm_word_t *ptrvalue)
+{
+  volatile stm_word_t *lock;
+  stm_word_t l, l2, t, value, version;
+  w_entry_t *w;
+  int decision;
+
+  PRINT_DEBUG2("==> stm_read_visible(t=%p[%lu-%lu],a=%p)\n", tx, (unsigned long)tx->start, (unsigned long)tx->end, addr);
+
+  if (GET_STATUS(tx->status) == TX_KILLED) {
+	*ptrvalue = value;
+    return stm_rollback(tx, STM_ABORT_KILLED);
+    //return 0;
+  }
+
+  /* Get reference to lock */
+  lock = GET_LOCK(addr);
+
+  /* Try to acquire lock */
+ restart:
+  l = ATOMIC_LOAD_ACQ(lock);
+ restart_no_load:
+  if (LOCK_GET_OWNED(l)) {
+    /* Locked */
+    if (l == LOCK_UNIT) {
+      /* Data modified by a unit store: should not last long => retry */
+      goto restart;
+    }
+    /* Do we own the lock? */
+    w = (w_entry_t *)LOCK_GET_ADDR(l);
+    /* Simply check if address falls inside our write set (avoids non-faulting load) */
+    if (tx->w_set.entries <= w && w < tx->w_set.entries + tx->w_set.nb_entries) {
+      /* Yes: is it only read-locked? */
+      if (!LOCK_GET_WRITE(l)) {
+        /* Yes: get value from memory */
+        value = ATOMIC_LOAD(addr);
+      } else {
+        /* No: did we previously write the same address? */
+        while (1) {
+          if (addr == w->addr) {
+            /* Yes: get value from write set (or from memory if mask was empty) */
+            value = (w->mask == 0 ? ATOMIC_LOAD(addr) : w->value);
+            break;
+          }
+          if (w->next == NULL) {
+            /* No: get value from memory */
+            value = ATOMIC_LOAD(addr);
+            break;
+          }
+          w = w->next;
+        }
+      }
+# if CM == CM_MODULAR
+      if (GET_STATUS(tx->status) == TX_KILLED) {
+    	*ptrvalue = 0;
+        return stm_rollback(tx, STM_ABORT_KILLED);
+        //return 0;
+      }
+# endif
+      /* No need to add to read set (will remain valid) */
+      //return value;
+      *ptrvalue = value;
+      return SUCCESS;
+    }
+    /* Conflict: CM kicks in */
+    t = w->tx->status;
+    l2 = ATOMIC_LOAD_ACQ(lock);
+    if (l != l2) {
+      l = l2;
+      goto restart_no_load;
+    }
+    if (t != w->tx->status) {
+      /* Transaction status has changed: restart the whole procedure */
+      goto restart;
+    }
+    if (GET_STATUS(t) == TX_KILLED) {
+      /* We can safely steal lock */
+      decision = KILL_OTHER;
+    } else {
+      decision =
+# ifdef IRREVOCABLE_ENABLED
+        GET_STATUS(tx->status) == TX_IRREVOCABLE ? KILL_OTHER :
+        GET_STATUS(t) == TX_IRREVOCABLE ? KILL_SELF :
+# endif /* IRREVOCABLE_ENABLED */
+        GET_STATUS(tx->status) == TX_KILLED ? KILL_SELF :
+        (contention_manager != NULL ? contention_manager(tx, w->tx, (LOCK_GET_WRITE(l) ? WR_CONFLICT : RR_CONFLICT)) : KILL_SELF);
+      if (decision == KILL_OTHER) {
+        /* Kill other */
+        if (!stm_kill(tx, w->tx, t)) {
+          /* Transaction may have committed or aborted: retry */
+          goto restart;
+        }
+      }
+    }
+    if (decision == KILL_OTHER) {
+      version = w->version;
+      goto acquire;
+    }
+    /* Kill self */
+    if ((decision & DELAY_RESTART) != 0)
+      tx->c_lock = lock;
+    /* Abort */
+# ifdef INTERNAL_STATS
+    tx->aborts_locked_read++;
+# endif /* INTERNAL_STATS */
+# ifdef CONFLICT_TRACKING
+    if (conflict_cb != NULL && l != LOCK_UNIT) {
+      /* Call conflict callback */
+      stm_tx_t *other = ((w_entry_t *)LOCK_GET_ADDR(l))->tx;
+      conflict_cb(tx, other);
+    }
+# endif /* CONFLICT_TRACKING */
+    *ptrvalue = 0;
+    return stm_rollback(tx, (LOCK_GET_WRITE(l) ? STM_ABORT_WR_CONFLICT : STM_ABORT_RR_CONFLICT));
+    //return 0;
+  }
+  /* Not locked */
+  version = LOCK_GET_TIMESTAMP(l);
+ acquire:
+  /* Acquire lock (ETL) */
+  if (tx->w_set.nb_entries == tx->w_set.size)
+    stm_allocate_ws_entries(tx, 1);
+  w = &tx->w_set.entries[tx->w_set.nb_entries];
+  w->version = version;
+  value = ATOMIC_LOAD(addr);
+  //if (ATOMIC_CAS_FULL(lock, l, LOCK_SET_ADDR_READ((stm_word_t)w)) == 0)
+  if (ATOMIC_CAS_FULL(lock, l, LOCK_SET_ADDR_READ((stm_word_t)w)) != l)
+    goto restart;
+  /* Add entry to write set */
+  w->addr = addr;
+  w->mask = 0;
+  w->lock = lock;
+  w->value = value;
+  w->next = NULL;
+  tx->w_set.nb_entries++;
+  *ptrvalue = value;
+  //return value;
+  return SUCCESS;
+}
+#endif /* CM == CM_MODULAR */
+
+/*
+ * Store a word-sized value (return write set entry or NULL).
+ */
+// NEW version RETURNS ROLLBACK_ REQUESTED NO_RETRY or SUCCESS
+// NEW version RETURNS ROLLBACK_ REQUESTED NO_RETRY or SUCCESS - TODO
+// WAS static inline w_entry_t *stm_write(stm_tx_t *tx, volatile stm_word_t *addr, stm_word_t value, stm_word_t mask)
+static int stm_write(stm_tx_t *tx, volatile stm_word_t *addr, stm_word_t value, stm_word_t mask)
+{
+  volatile stm_word_t *lock;
+  stm_word_t l, version;
+  w_entry_t *w;
+#if DESIGN == WRITE_BACK_ETL
+  w_entry_t *prev = NULL;
+#elif DESIGN == WRITE_THROUGH
+  int duplicate = 0;
+#endif /* DESIGN == WRITE_THROUGH */
+#if CM == CM_MODULAR
+  int decision;
+  stm_word_t l2, t;
+#endif /* CM == CM_MODULAR */
+
+  PRINT_DEBUG2("==> stm_write(t=%p[%lu-%lu],a=%p,d=%p-%lu,m=0x%lx)\n",
+               tx, (unsigned long)tx->start, (unsigned long)tx->end, addr, (void *)value, (unsigned long)value, (unsigned long)mask);
+
+#if CM == CM_MODULAR
+  if (GET_STATUS(tx->status) == TX_KILLED) {
+    return stm_rollback(tx, STM_ABORT_KILLED);
+//    return NULL;
+  }
+#else /* CM != CM_MODULAR */
+  assert(IS_ACTIVE(tx->status));
+#endif /* CM !=  CM_MODULAR */
+
+  if (tx->ro) {
+    /* Disable read-only and abort */
+  //  assert(tx->attr != NULL);
+    /* Update attributes to inform the caller */ // ---> the caller will never know the difference
+    tx->attr.read_only = 0;
+#ifdef INTERNAL_STATS
+    tx->aborts_ro++;
+#endif /* INTERNAL_STATS */
+    return stm_rollback(tx, STM_ABORT_RO_WRITE);
+//    return NULL;
+  }
+
+  /* Get reference to lock */
+  lock = GET_LOCK(addr);
+
+  /* Try to acquire lock */
+ restart:
+#if CM == CM_DELAY && defined(WAIT_COND)
+  mutex_lock(&(locks_mutex[LOCK_IDX(addr)]));
+ 	  l = *lock;
+  mutex_unlock(&(locks_mutex[LOCK_IDX(addr)]));
+#else /* CM != CM_DELAY && defined(WAIT_COND) */
+  l = ATOMIC_LOAD_ACQ(lock);
+#endif /* CM != CM_DELAY && defined(WAIT_COND) */
+
+  PRINT_DEBUG3("%s: lock %p l %p *lock %d (locks %p %d) init %d\n",
+		  __func__, lock, l, *lock, locks, LOCK_ARRAY_SIZE, initialized);
+
+ restart_no_load:
+  if (LOCK_GET_OWNED(l)) {
+    /* Locked */
+    if (l == LOCK_UNIT) {
+      /* Data modified by a unit store: should not last long => retry */
+      goto restart;
+    }
+    /* Do we own the lock? */
+#if DESIGN == WRITE_THROUGH
+    if (tx == (stm_tx_t *)LOCK_GET_ADDR(l)) {
+      /* Yes */
+# ifdef NO_DUPLICATES_IN_RW_SETS
+      int i;
+      /* Check if address is in write set (a lock may cover multiple addresses) */
+      w = tx->w_set.entries;
+      for (i = tx->w_set.nb_entries; i > 0; i--, w++) {
+        if (w->addr == addr) {
+          if (mask == 0)
+            //return w;
+        	  return SUCCESS;
+          if (w->mask == 0) {
+            /* Remember old value */
+            w->value = ATOMIC_LOAD(addr);
+            w->mask = mask;
+          }
+          /* Yes: only write to memory */
+          if (mask != ~(stm_word_t)0)
+            value = (ATOMIC_LOAD(addr) & ~mask) | (value & mask);
+          ATOMIC_STORE(addr, value);
+          //return w;
+          return SUCCESS;
+        }
+      }
+# endif /* NO_DUPLICATES_IN_RW_SETS */
+      /* Mark entry so that we do not drop the lock upon undo */
+      duplicate = 1;
+      /* Must add to write set (may add entry multiple times) */
+      goto do_write;
+    }
+#elif DESIGN == WRITE_BACK_ETL
+    w = (w_entry_t *)LOCK_GET_ADDR(l);
+    PRINT_DEBUG3("%s: w %p w_set.entries %p w_set.nb_entries %d\n",
+    		__func__, w, tx->w_set.entries, tx->w_set.nb_entries);
+    /* Simply check if address falls inside our write set (avoids non-faulting load) */
+    if (tx->w_set.entries <= w && w < tx->w_set.entries + tx->w_set.nb_entries) {
+      /* Yes */
+#if CM == CM_MODULAR
+      /* If read-locked: upgrade lock */
+      if (!LOCK_GET_WRITE(l)) {
+        //if (ATOMIC_CAS_FULL(lock, l, LOCK_UPGRADE(l)) == 0) {
+        if (ATOMIC_CAS_FULL(lock, l, LOCK_UPGRADE(l)) != l) {
+          /* Lock must have been stolen: abort */
+          return stm_rollback(tx, STM_ABORT_KILLED);
+          //return NULL;
+        }
+        tx->w_set.has_writes++;
+      }
+#endif /* CM == CM_MODULAR */
+      if (mask == 0) {
+        /* No need to insert new entry or modify existing one */
+        //return w;
+    	  return SUCCESS;
+      }
+      prev = w;
+      /* Did we previously write the same address? */
+      while (1) {
+        if (addr == prev->addr) {
+          /* No need to add to write set */
+          if (mask != ~(stm_word_t)0) {
+            if (prev->mask == 0) {
+                /* CHECK USER SPACE ADDRESS ACCESS */
+                if (!access_ok(VERIFY_READ, addr, sizeof(value)))
+              	  printk("%s: access_ok addr %p size %d error [%d]\n",__func__, addr, sizeof(value), current->pid);
+                prev->value = ATOMIC_LOAD(addr);
+            }
+            value = (prev->value & ~mask) | (value & mask);
+          }
+          prev->value = value;
+          prev->mask |= mask;
+          //return prev;
+          return SUCCESS;
+        }
+        if (prev->next == NULL) {
+          /* Remember last entry in linked list (for adding new entry) */
+          break;
+        }
+        prev = prev->next;
+      }
+      /* Get version from previous write set entry (all entries in linked list have same version) */
+      version = prev->version;
+      /* Must add to write set */
+      if (tx->w_set.nb_entries == tx->w_set.size)
+        stm_allocate_ws_entries(tx, 1);
+      w = &tx->w_set.entries[tx->w_set.nb_entries];
+# if CM == CM_MODULAR
+      w->version = version;
+# endif /* CM == CM_MODULAR */
+      goto do_write;
+    }
+#endif /* DESIGN == WRITE_BACK_ETL */
+#if DESIGN == WRITE_BACK_CTL
+    /* Spin while locked (should not last long) */
+    goto restart;
+#else /* DESIGN != WRITE_BACK_CTL */
+    /* Conflict: CM kicks in */
+# if CM != CM_MODULAR && defined(IRREVOCABLE_ENABLED)
+    if (tx->irrevocable) {
+      /* Spin while locked */
+      goto restart;
+    }
+# endif /* CM != CM_MODULAR && defined(IRREVOCABLE_ENABLED) */
+# if CM == CM_MODULAR
+    t = w->tx->status;
+    l2 = ATOMIC_LOAD_ACQ(lock);
+    if (l != l2) {
+      l = l2;
+      goto restart_no_load;
+    }
+    if (t != w->tx->status) {
+      /* Transaction status has changed: restart the whole procedure */
+      goto restart;
+    }
+    if (GET_STATUS(t) == TX_KILLED) {
+      /* We can safely steal lock */
+      decision = KILL_OTHER;
+    } else {
+      decision =
+# ifdef IRREVOCABLE_ENABLED
+        GET_STATUS(tx->status) == TX_IRREVOCABLE ? KILL_OTHER :
+        GET_STATUS(t) == TX_IRREVOCABLE ? KILL_SELF :
+# endif /* IRREVOCABLE_ENABLED */
+        GET_STATUS(tx->status) == TX_KILLED ? KILL_SELF :
+        (contention_manager != NULL ? contention_manager(tx, w->tx, WW_CONFLICT) : KILL_SELF);
+      if (decision == KILL_OTHER) {
+        /* Kill other */
+        if (!stm_kill(tx, w->tx, t)) {
+          /* Transaction may have committed or aborted: retry */
+          goto restart;
+        }
+      }
+    }
+    if (decision == KILL_OTHER) {
+      /* Handle write after reads (before CAS) */
+      version = w->version;
+      goto acquire;
+    }
+    /* Kill self */
+    if ((decision & DELAY_RESTART) != 0)
+      tx->c_lock = lock;
+# elif CM == CM_DELAY
+    tx->c_lock = lock;
+# endif /* CM == CM_DELAY */
+    /* Abort */
+# ifdef INTERNAL_STATS
+    tx->aborts_locked_write++;
+# endif /* INTERNAL_STATS */
+# ifdef CONFLICT_TRACKING
+    if (conflict_cb != NULL && l != LOCK_UNIT) {
+      /* Call conflict callback */
+#  if DESIGN == WRITE_THROUGH
+      stm_tx_t *other = (stm_tx_t *)LOCK_GET_ADDR(l);
+#  else /* DESIGN != WRITE_THROUGH */
+      stm_tx_t *other = ((w_entry_t *)LOCK_GET_ADDR(l))->tx;
+#  endif /* DESIGN != WRITE_THROUGH */
+      conflict_cb(tx, other);
+    }
+# endif /* CONFLICT_TRACKING */
+    return stm_rollback(tx, STM_ABORT_WW_CONFLICT);
+    //return NULL;
+#endif /* DESIGN != WRITE_BACK_CTL */
+  }
+  /* Not locked */
+#if DESIGN == WRITE_BACK_CTL
+  w = stm_has_written(tx, addr);
+  if (w != NULL) {
+    w->value = (w->value & ~mask) | (value & mask);
+    w->mask |= mask;
+    //return w;
+    return SUCCESS;
+  }
+#endif /* DESIGN == WRITE_BACK_CTL */
+  /* Handle write after reads (before CAS) */
+  version = LOCK_GET_TIMESTAMP(l);
+#ifdef IRREVOCABLE_ENABLED
+  /* In irrevocable mode, no need to revalidate */
+  if (tx->irrevocable)
+    goto acquire_no_check;
+#endif /* IRREVOCABLE_ENABLED */
+ acquire:
+  PRINT_DEBUG3("version %d > tx->end %d tx->no_retry %d tx->ro %d tx->can_extend %d addr %p l %p lock %p\n",
+ 		version, tx->end, tx->attr.no_retry, tx->ro, tx->can_extend, addr, l, lock);
+  /* valid version? */
+  if (version > tx->end) {
+    /* We might have read an older version previously */
+    if (!tx->can_extend || stm_has_read(tx, lock) != NULL) {
+      /* Read version must be older (otherwise, tx->end >= version) */
+      /* Not much we can do: abort */
+#if CM == CM_MODULAR
+      /* Abort caused by invisible reads */
+      tx->visible_reads++;
+#endif /* CM == CM_MODULAR */
+#ifdef INTERNAL_STATS
+      tx->aborts_validate_write++;
+#endif /* INTERNAL_STATS */
+      return stm_rollback(tx, STM_ABORT_VAL_WRITE);
+      //return NULL;
+    }
+  }
+  /* Acquire lock (ETL) */
+#ifdef IRREVOCABLE_ENABLED
+ acquire_no_check:
+#endif /* IRREVOCABLE_ENABLED */
+#if DESIGN == WRITE_THROUGH
+  //if (ATOMIC_CAS_FULL(lock, l, LOCK_SET_ADDR_WRITE((stm_word_t)tx)) == 0)
+  if (ATOMIC_CAS_FULL(lock, l, LOCK_SET_ADDR_WRITE((stm_word_t)tx)) != l)
+    goto restart;
+#elif DESIGN == WRITE_BACK_ETL
+  if (tx->w_set.nb_entries == tx->w_set.size)
+    stm_allocate_ws_entries(tx, 1);
+  w = &tx->w_set.entries[tx->w_set.nb_entries];
+# if CM == CM_MODULAR
+  w->version = version;
+# endif /* if CM == CM_MODULAR */
+#if CM == CM_DELAY && defined(WAIT_COND)
+  mutex_lock(&(locks_mutex[LOCK_IDX(addr)]));
+  	  if ( *lock != l ) {
+  		  mutex_unlock(&(locks_mutex[LOCK_IDX(addr)]));
+  		  goto restart;
+  	  }
+  	  *lock = LOCK_SET_ADDR_WRITE((stm_word_t)w);
+  	  //pthread_cond_broadcast(&(locks_cond[LOCK_IDX(addr)])); //we are not releasing but acquiring a lock
+  mutex_unlock(&(locks_mutex[LOCK_IDX(addr)]));
+#else /* CM != CM_DELAY && defined(WAIT_COND) */
+  if (ATOMIC_CAS_FULL(lock, l, LOCK_SET_ADDR_WRITE((stm_word_t)w)) != l) {
+	  //	 printk("%s: failed to Acquire Lock ETL lock %p *lock %d l %d LSAW w %p\n",
+	  //			 __func__, lock, *lock, l, LOCK_SET_ADDR_WRITE((stm_word_t)w));
+    goto restart; }
+#endif /* CM != CM_DELAY && defined(WAIT_COND) */
+#endif /* DESIGN == WRITE_BACK_ETL */
+  /* We own the lock here (ETL) */
+do_write:
+  /* Add address to write set */
+#if DESIGN != WRITE_BACK_ETL
+  if (tx->w_set.nb_entries == tx->w_set.size)
+    stm_allocate_ws_entries(tx, 1);
+  w = &tx->w_set.entries[tx->w_set.nb_entries++];
+#endif /* DESIGN != WRITE_BACK_ETL */
+  w->addr = addr;
+  w->mask = mask;
+  w->lock = lock;
+  if (mask == 0) {
+    /* Do not write anything */
+#ifndef NDEBUG
+    w->value = 0;
+#endif /* ! NDEBUG */
+  } else
+#if DESIGN == WRITE_THROUGH
+  {
+    /* Remember old value */
+    w->value = ATOMIC_LOAD(addr);
+  }
+  /* We store the old value of the lock (timestamp and incarnation) */
+  w->version = l;
+  w->no_drop = duplicate;
+  if (mask != 0) {
+    if (mask != ~(stm_word_t)0)
+      value = (w->value & ~mask) | (value & mask);
+    ATOMIC_STORE(addr, value);
+  }
+#elif DESIGN == WRITE_BACK_ETL
+  {
+    /* Remember new value */
+    if (mask != ~(stm_word_t)0) {
+      /* CHECK USER SPACE ADDRESS ACCESS */
+      if (!access_ok(VERIFY_READ, addr, sizeof(value)))
+    	  printk("%s: access_ok addr %p size %d error [%d]\n",__func__, addr, sizeof(value), current->pid);
+      stm_word_t tmp = ATOMIC_LOAD(addr);
+      value = (tmp & ~mask) | (value & mask);
+    }
+    w->value = value;
+  }
+# if CM != CM_MODULAR
+  w->version = version;
+# endif /* CM != CM_MODULAR */
+  w->next = NULL;
+  if (prev != NULL) {
+    /* Link new entry in list */
+    prev->next = w;
+  }
+  tx->w_set.nb_entries++;
+  tx->w_set.has_writes++;
+#else /* DESIGN == WRITE_BACK_CTL */
+  {
+    /* Remember new value */
+    w->value = value;
+  }
+# ifndef NDEBUG
+  w->version = version;
+# endif
+  w->no_drop = 1;
+# ifdef USE_BLOOM_FILTER
+  tx->w_set.bloom |= FILTER_BITS(addr) ;
+# endif /* USE_BLOOM_FILTER */
+#endif /* DESIGN == WRITE_BACK_CTL */
+
+#ifdef IRREVOCABLE_ENABLED
+  if (!tx->irrevocable && ATOMIC_LOAD_ACQ(&irrevocable)) {
+    return stm_rollback(tx, STM_ABORT_IRREVOCABLE);
+    //return NULL;
+  }
+#endif /* IRREVOCABLE_ENABLED */
+
+//  return w;
+  return SUCCESS;
+}
+
+/*
+ * Store a word-sized value in a unit transaction. -> STRONG ATOMICITY SUPPORT
+ */
+static inline int stm_unit_write(volatile stm_word_t *addr, stm_word_t value, stm_word_t mask, stm_word_t *timestamp)
+{
+  volatile stm_word_t *lock;
+  stm_word_t l;
+
+  PRINT_DEBUG2("==> stm_unit_write(a=%p,d=%p-%lu,m=0x%lx)\n",
+               addr, (void *)value, (unsigned long)value, (unsigned long)mask);
+
+  /* Get reference to lock */
+  lock = GET_LOCK(addr);
+
+  /* Try to acquire lock */
+ restart:
+#if CM == CM_DELAY && defined(WAIT_COND)
+  mutex_lock(&(locks_mutex[LOCK_IDX(addr)]));
+  	  l = *lock;
+  mutex_unlock(&(locks_mutex[LOCK_IDX(addr)]));
+#else /* CM != CM_DELAY && defined(WAIT_COND) */
+  l = ATOMIC_LOAD_ACQ(lock);
+#endif /* CM == CM_DELAY && defined(WAIT_COND) */
+
+  if (LOCK_GET_OWNED(l)) {
+    /* Locked: wait until lock is free */
+#ifdef WAIT_YIELD
+    yield();
+#endif /* WAIT_YIELD */
+    goto restart;
+  }
+  /* Not locked */
+  if (timestamp != NULL && LOCK_GET_TIMESTAMP(l) > *timestamp) {
+    /* Return current timestamp */
+    *timestamp = LOCK_GET_TIMESTAMP(l);
+    return 0;
+  }
+  /* TODO: would need to store thread ID to be able to kill it (for wait freedom) */
+#if CM == CM_DELAY && defined(WAIT_COND)
+  mutex_lock(&(locks_mutex[LOCK_IDX(addr)]));
+  	  if ( *lock != l ) {
+  		  mutex_unlock(&(locks_mutex[LOCK_IDX(addr)]));
+  		  goto restart;
+  	  }
+  	  *lock = LOCK_UNIT;
+  	  //pthread_cond_broadcast(&(locks_cond[LOCK_IDX(addr)])); //we are not releasing but acquiring a lock
+  mutex_unlock(&(locks_mutex[LOCK_IDX(addr)]));
+#else
+  if (ATOMIC_CAS_FULL(lock, l, LOCK_UNIT) == l) // means failure in ATOMIC_CAS_FULL
+	  goto restart;
+#endif
+  ATOMIC_STORE(addr, value);
+  /* Update timestamp with newer value (may exceed VERSION_MAX by up to MAX_THREADS) */
+  l = FETCH_INC_CLOCK;
+  if (timestamp != NULL)
+    *timestamp = l;
+  /* Make sure that lock release becomes visible */
+#if CM == CM_DELAY && defined(WAIT_COND)
+  mutex_lock(&(locks_mutex[LOCK_IDX(addr)]));
+  	  *lock = LOCK_SET_TIMESTAMP(l);
+  	  cond_broadcast(&(locks_cond[LOCK_IDX(addr)]));
+  mutex_unlock(&(locks_mutex[LOCK_IDX(addr)]));
+#else /* CM != CM_DELAY && defined(WAIT_COND) */
+  ATOMIC_STORE_REL(lock, LOCK_SET_TIMESTAMP(l));
+#endif /* CM != CM_DELAY && defined(WAIT_COND) */
+  if (l >= VERSION_MAX) {
+    /* Block all transactions and reset clock (current thread is not in active transaction) */
+    stm_quiesce_barrier(NULL, rollover_clock, NULL);
+  }
+  return 1;
+}
+
+/*
+ * Catch signal (to emulate non-faulting load).
+ */
+static void signal_catcher(int sig)
+{
+  stm_tx_t *tx = stm_get_tx();
+
+  /* A fault might only occur upon a load concurrent with a free (read-after-free) */
+  PRINT_DEBUG("Caught signal: %d\n", sig);
+
+  //if (tx == NULL || (tx->attr != NULL && tx->attr->no_retry)) {
+  if (tx == NULL || ( tx->attr.no_retry)) {
+    /* There is not much we can do: execution will restart at faulty load */
+	  PRINT_ERR( "Error: invalid memory accessed and no longjmp destination\n");
+//    exit(1);
+  }
+
+#ifdef INTERNAL_STATS
+  tx->aborts_invalid_memory++;
+#endif /* INTERNAL_STATS */
+  /* Will cause a longjmp */
+  stm_rollback(tx, STM_ABORT_SIGNAL);
+}
+
+/* ################################################################### *
+ * STM FUNCTIONS
+ * ################################################################### */
+
+/*
+ * Called once (from main) to initialize STM infrastructure.
+ */
+//NOTA
+//if registered at init this will be called just once an not for every process
+//different processes have different addr space with the same ranges of addresses
+int __init stm_init(void)
+{
+#if CM == CM_MODULAR
+  char *s;
+#endif /* CM == CM_MODULAR */
+
+  PRINT_DEBUG("==> stm_init()\n");
+  //printk("==> stm_init()\n"); // add a general message that tell the user that this system run LinuxSTM! :-)
+
+  if (initialized)
+    return -EPERM;
+
+  PRINT_DEBUG("\tsizeof(word)=%d\n", (int)sizeof(stm_word_t));
+  PRINT_DEBUG("\tVERSION_MAX=0x%lx\n", (unsigned long)VERSION_MAX);
+
+  COMPILE_TIME_ASSERT(sizeof(stm_word_t) == sizeof(void *));
+#ifndef CONFIG_64BIT
+  COMPILE_TIME_ASSERT(sizeof(stm_word_t) == sizeof(atomic_t));
+#else
+  COMPILE_TIME_ASSERT(sizeof(stm_word_t) == sizeof(atomic64_t));
+#endif
+
+  //TODO TODO TODO
+  //must be allocated per process, stm_init must be called by the process (to ease all these problems)
+  // but a shared lock part for the kernel will be useful in a futher version of the software
+  memset((void *)locks, 0, LOCK_ARRAY_SIZE * sizeof(stm_word_t));
+
+#if CM == CM_MODULAR
+  s = getenv(VR_THRESHOLD);
+  if (s != NULL)
+    vr_threshold = (int)strtol(s, NULL, 10);
+  else
+    vr_threshold = VR_THRESHOLD_DEFAULT;
+  PRINT_DEBUG("\tVR_THRESHOLD=%d\n", vr_threshold);
+#endif /* CM == CM_MODULAR */
+
+#if CM == CM_DELAY && defined(WAIT_COND)
+  { int i;
+  for (i=0; i<LOCK_ARRAY_SIZE; i++) {
+	  mutex_init(&locks_mutex[i]);
+	  init_waitqueue_head(&locks_cond[i]); }
+  }
+#endif /* CM == CM_DELAY && defined(WAIT_COND) */
+
+  CLOCK = 0;
+  stm_quiesce_init();
+
+/* NOT REQUIRED IN KERNEL
+#ifndef TLS
+  if (pthread_key_create(&thread_tx, NULL) != 0) {
+	  PRINT_ERR( "Error creating thread local\n");
+    exit(1);
+  }
+#endif
+*/
+
+//create the kmem cache for stm_tx_t objects
+//cache usage is tracked by the operating system
+//  kmem_cache_create (const char *name, size_t size,
+ // size_t align, unsigned long flags, void (*ctor)(void *))
+
+  stm_tx_cache = kmem_cache_create("stm_tx_t", sizeof(stm_tx_t),
+		  ARCH_SLAB_MINALIGN, (SLAB_HWCACHE_ALIGN | SLAB_PANIC | SLAB_NOTRACK), NULL);
+  if (!stm_tx_cache) {
+	  printk("ERROR ERROR ERROR kmem_cache_create");
+	  initialized = 0;
+	  return -ENOMEM;
+  }
+
+  memset(locks, 0, (sizeof(stm_word_t)*LOCK_ARRAY_SIZE)); // per process @ least we can support shared memory
+  nb_specific = 0; // per process
+
+  initialized = 1;
+  return 0;
+}
+__initcall(stm_init);
+
+// this is the only place where we used _user because of the signal registration // i.e. still TODO TODO TODO
+static void stm_init_user(void)
+{
+#ifndef EPOCH_GC
+//  struct sigaction act; // TODO
+#endif /* ! EPOCH_GC */
+
+#ifdef EPOCH_GC
+  gc_init(stm_get_clock);
+#endif /* EPOCH_GC */
+
+#ifndef EPOCH_GC
+//  if (getenv(NO_SIGNAL_HANDLER) == NULL) {
+    /* Catch signals for non-faulting load */
+//    act.sa_handler = signal_catcher;
+//    act.sa_flags = 0;
+//    sigemptyset(&act.sa_mask);
+//    if (sigaction(SIGBUS, &act, NULL) < 0 || sigaction(SIGSEGV, &act, NULL) < 0) {
+      PERROR("sigaction");
+//      exit(1);
+//    }
+//  }
+#endif /* ! EPOCH_GC */
+}
+
+/*
+ * Called once (from main) to clean up STM infrastructure.
+ */
+void stm_exit()
+{
+  PRINT_DEBUG("==> stm_exit()\n");
+
+  //delete the kmemcache allocated in stm_init
+  if (stm_tx_cache)
+	  kmem_cache_destroy(stm_tx_cache);
+
+/*#ifndef TLS not required in kernel
+  pthread_key_delete(thread_tx);
+#endif
+*/
+  stm_quiesce_exit();
+
+#if CM == CM_DELAY && defined(WAIT_COND)
+  { int i;
+  for (i=0; i<LOCK_ARRAY_SIZE; i++) {
+//	  cond_destroy(&locks_cond[i]);
+	  mutex_destroy(&locks_mutex[i]);
+  }
+  }
+#endif /* CM == CM_DELAY  && defined(WAIT_COND)*/
+
+#ifdef EPOCH_GC
+  gc_exit();
+#endif /* EPOCH_GC */
+}
+__exitcall(stm_exit);
+
+/*
+ * CALLED by linux/fork.c:1061 copy_process
+ * Called by the CURRENT thread to initialize thread-local STM data.
+ */
+stm_tx_t * stm_init_thread()
+{
+  stm_tx_t *tx;
+
+  PRINT_DEBUG("==> stm_init_thread()\n");
+
+  if ( !initialized )
+	  return 0;
+
+//  if ((tx = stm_get_tx()) != NULL)
+//    TX_RETURN;
+
+#ifdef EPOCH_GC
+  gc_init_thread();
+#endif /* EPOCH_GC */
+
+  /* Allocate descriptor */
+/*  if ((tx = (stm_tx_t *)malloc(sizeof(stm_tx_t))) == NULL) {
+    PERROR("malloc tx");
+    exit(1);
+  }
+  */
+// in kernel we get the descriptor from the kmem cache (statistics in /proc/slab..)
+  //tx = kmem_cache_alloc(stm_tx_cache, GFP_KERNEL);
+  tx = kmem_cache_zalloc(stm_tx_cache, GFP_KERNEL);
+  if (!tx ) {
+	  PERROR("kmem_cache_alloc fails");
+	  return 0;
+  }
+  tx->snapshot = 0;
+
+  /* Set status (no need for CAS or atomic op) */
+  tx->status = TX_IDLE;
+  /* Read set */
+  tx->r_set.nb_entries = 0;
+  tx->r_set.size = RW_SET_SIZE;
+  stm_allocate_rs_entries(tx, 0);
+  /* Write set */
+  tx->w_set.nb_entries = 0;
+  tx->w_set.size = RW_SET_SIZE;
+#if DESIGN == WRITE_BACK_CTL
+  tx->w_set.nb_acquired = 0;
+# ifdef USE_BLOOM_FILTER
+  tx->w_set.bloom = 0;
+# endif /* USE_BLOOM_FILTER */
+#endif /* DESIGN == WRITE_BACK_CTL */
+  stm_allocate_ws_entries(tx, 0);
+  /* Nesting level */
+  tx->nesting = 0; // here reset nesting to 0..
+  /* Transaction-specific data */
+  memset(tx->data, 0, MAX_SPECIFIC * sizeof(void *));
+#ifdef CONFLICT_TRACKING
+  /* Thread identifier */
+  tx->thread_id = pthread_self();
+#endif /* CONFLICT_TRACKING */
+#if CM == CM_DELAY || CM == CM_MODULAR
+  /* Contented lock */
+  tx->c_lock = NULL;
+#endif /* CM == CM_DELAY || CM == CM_MODULAR */
+#if CM == CM_BACKOFF
+  /* Backoff */
+  tx->backoff = MIN_BACKOFF;
+  tx->seed = 123456789UL;
+#endif /* CM == CM_BACKOFF */
+#if CM == CM_MODULAR
+  tx->visible_reads = 0;
+  tx->timestamp = 0;
+#endif /* CM == CM_MODULAR */
+#if CM == CM_MODULAR || defined(INTERNAL_STATS)
+  tx->retries = 0;
+#endif /* CM == CM_MODULAR || defined(INTERNAL_STATS) */
+#ifdef INTERNAL_STATS
+  /* Statistics */
+  tx->aborts = 0;
+  tx->aborts_1 = 0;
+  tx->aborts_2 = 0;
+  tx->aborts_ro = 0;
+  tx->aborts_locked_read = 0;
+  tx->aborts_locked_write = 0;
+  tx->aborts_validate_read = 0;
+  tx->aborts_validate_write = 0;
+  tx->aborts_validate_commit = 0;
+  tx->aborts_invalid_memory = 0;
+# if CM == CM_MODULAR
+  tx->aborts_killed = 0;
+# endif /* CM == CM_MODULAR */
+# ifdef READ_LOCKED_DATA
+  tx->locked_reads_ok = 0;
+  tx->locked_reads_failed = 0;
+# endif /* READ_LOCKED_DATA */
+  tx->max_retries = 0;
+#endif /* INTERNAL_STATS */
+  /* Store as thread-local data */ // NOT REQUIRED IN KERNEL
+/*#ifdef TLS
+  thread_tx = tx;
+#else
+  pthread_setspecific(thread_tx, tx);
+#endif
+*/
+  stm_quiesce_enter_thread(tx);
+
+  /* Callbacks */
+/*  if (nb_init_cb != 0) {
+    int cb;
+    for (cb = 0; cb < nb_init_cb; cb++)
+      init_cb[cb].f(TXARGS init_cb[cb].arg);
+  }
+*/
+  mod_stats_on_thread_init(tx);
+//  TX_RETURN;
+  return tx;
+}
+
+/*
+ * CALLED by linux/exit.c:954 do_exit
+ * Called by the CURRENT thread to cleanup thread-local STM data.
+ */
+//void stm_exit_thread(TXPARAM)
+void stm_exit_thread(stm_tx_t * tx)
+{
+#ifdef EPOCH_GC
+  stm_word_t t;
+#endif /* EPOCH_GC */
+  //TX_GET;
+  if (!initialized)
+	  return;
+  if ( !tx )
+	  return;
+
+  PRINT_DEBUG("==> stm_exit_thread(%p[%lu-%lu])\n", tx, (unsigned long)tx->start, (unsigned long)tx->end);
+
+
+  mod_stats_on_thread_exit();
+  /* Callbacks */
+/*  if (nb_exit_cb != 0) {
+    int cb;
+    for (cb = 0; cb < nb_exit_cb; cb++)
+      exit_cb[cb].f(TXARGS exit_cb[cb].arg);
+  }
+*/
+  stm_quiesce_exit_thread(tx);
+
+// TODO move EPOCH_GC support in user space
+#ifdef EPOCH_GC
+  t = GET_CLOCK;
+  gc_free(tx->r_set.entries, t);
+  gc_free(tx->w_set.entries, t);
+  gc_free(tx, t);
+  gc_exit_thread();
+#else /* ! EPOCH_GC */
+  vfree(tx->r_set.entries);
+  vfree(tx->w_set.entries);
+
+  kmem_cache_free(stm_tx_cache, tx);
+#endif /* ! EPOCH_GC */
+
+/*#ifdef TLS not required in kernel
+  thread_tx = NULL;
+#else
+  pthread_setspecific(thread_tx, NULL);
+#endif
+*/
+}
+
+/*
+ * Called by the CURRENT thread to start a transaction.
+ */
+// in the original version sigsetjmp is called in the main program
+// and siglongjmp is called in from the library by stm_rollback
+//sigjmp_buf *stm_start(TXPARAMS stm_tx_attr_t *attr)
+
+//int stm_start(void* stackaddr, int stacksize, chk_pnt * chk_user_data, struct pt_regs *regs)
+uintptr_t *stm_start(TXPARAMS stm_tx_attr_t *attr)
+{
+  TX_GET;
+  PRINT_DEBUG("==> stm_start(%p)\n", tx);
+
+  /* Increment nesting level */
+  if (tx->nesting++ > 0)
+    return NULL; // do not take the snapshot please! we are using flat nesting
+	// as a first version do use flat nesting
+
+  //first we take a snapshot of the system status then... ----> we took the snapshot in sys_stm_ctrl to mimic TinySTM
+ // int sys_snapshot(void* stackaddr, int stacksize, chk_pnt * chk_user_data, struct pt_regs *regs)
+
+  /* Attributes */
+  tx->attr = *attr;
+  tx->ro = (attr == NULL ? 0 : attr->read_only);
+#ifdef IRREVOCABLE_ENABLED
+  tx->irrevocable = 0;
+#endif /* IRREVOCABLE_ENABLED */
+
+  /* Initialize transaction descriptor */
+  stm_prepare(tx);
+
+  /* Callbacks */
+/*  if (nb_start_cb != 0) {
+    int cb;
+    for (cb = 0; cb < nb_start_cb; cb++)
+      start_cb[cb].f(TXARGS start_cb[cb].arg);
+  }
+*/
+  return &tx->snapshot; // ritorna un indirizzo , i.e. l'address del buffer di salvataggio!
+}
+
+/*
+ * Called by the CURRENT thread to commit a transaction.
+ */
+int stm_commit(TXPARAM)
+{
+  w_entry_t *w;
+  stm_word_t t;
+  int i;
+#if DESIGN == WRITE_BACK_CTL
+  stm_word_t l, value;
+#endif /* DESIGN == WRITE_BACK_CTL */
+  TX_GET;
+
+  PRINT_DEBUG("==> stm_commit(%p[%lu-%lu])\n", tx, (unsigned long)tx->start, (unsigned long)tx->end);
+
+  /* Decrement nesting level */
+  if (--tx->nesting > 0)
+    return SUCCESS; // this means that conflict checking is done at load/store level and on the final commit not partially (flat nesting)
+
+  assert(IS_ACTIVE(tx->status));
+#if CM == CM_MODULAR
+  /* Set status to COMMITTING */
+  t = tx->status;
+  if (GET_STATUS(t) == TX_KILLED
+		  || ATOMIC_CAS_FULL(&tx->status, t, t + (TX_COMMITTING - GET_STATUS(t))) != t) {
+	  //|| ATOMIC_CAS_FULL(&tx->status, t, t + (TX_COMMITTING - GET_STATUS(t))) == 0) {
+    /* We have been killed */
+    assert(GET_STATUS(tx->status) == TX_KILLED);
+    return stm_rollback(tx, STM_ABORT_KILLED);
+//    return 0;
+  }
+#endif /* CM == CM_MODULAR */
+
+  /* A read-only transaction can commit immediately */
+  if (tx->w_set.nb_entries == 0)
+    goto end;
+
+#if CM == CM_MODULAR
+  /* A read-only transaction with visible reads must simply drop locks */
+  if (tx->w_set.has_writes == 0) {
+    w = tx->w_set.entries;
+    for (i = tx->w_set.nb_entries; i > 0; i--, w++) {
+      /* Only drop lock for last covered address in write set */
+      if (w->next == NULL)
+        ATOMIC_STORE_REL(w->lock, LOCK_SET_TIMESTAMP(w->version));
+    }
+    /* Update clock so that future transactions get higher timestamp (liveness of timestamp CM) */
+    FETCH_INC_CLOCK;
+    goto end;
+  }
+#endif /* CM == CM_MODULAR */
+
+  /* Update transaction */
+#if DESIGN == WRITE_BACK_CTL
+# ifdef IRREVOCABLE_ENABLED
+  /* Verify already if there is an irrevocable transaction before acquiring locks */
+  if(!tx->irrevocable && ATOMIC_LOAD(&irrevocable)) {
+    return stm_rollback(tx, STM_ABORT_IRREVOCABLE);
+    //return 0;
+  }
+# endif /* IRREVOCABLE_ENABLED */
+  /* Acquire locks (in reverse order) */
+  w = tx->w_set.entries + tx->w_set.nb_entries;
+  do {
+    w--;
+    /* Try to acquire lock */
+ restart:
+    l = ATOMIC_LOAD(w->lock);
+    if (LOCK_GET_OWNED(l)) {
+      /* Do we already own the lock? */
+      if (tx->w_set.entries <= (w_entry_t *)LOCK_GET_ADDR(l) && (w_entry_t *)LOCK_GET_ADDR(l) < tx->w_set.entries + tx->w_set.nb_entries) {
+        /* Yes: ignore */
+        continue;
+      }
+      /* Conflict: CM kicks in */
+# if CM == CM_DELAY
+      tx->c_lock = w->lock;
+# endif /* CM == CM_DELAY */
+      /* Abort self */
+# ifdef INTERNAL_STATS
+      tx->aborts_locked_write++;
+# endif /* INTERNAL_STATS */
+      return stm_rollback(tx, STM_ABORT_WW_CONFLICT);
+      //return 0;
+    }
+    //if (ATOMIC_CAS_FULL(w->lock, l, LOCK_SET_ADDR_WRITE((stm_word_t)w)) == 0)
+    if (ATOMIC_CAS_FULL(w->lock, l, LOCK_SET_ADDR_WRITE((stm_word_t)w)) != l)
+      goto restart;
+    /* We own the lock here */
+    w->no_drop = 0;
+    /* Store version for validation of read set */
+    w->version = LOCK_GET_TIMESTAMP(l);
+    tx->w_set.nb_acquired++;
+  } while (w > tx->w_set.entries);
+#endif /* DESIGN == WRITE_BACK_CTL */
+
+#ifdef IRREVOCABLE_ENABLED
+  /* Verify if there is an irrevocable transaction once all locks have been acquired */
+  if (!tx->irrevocable && ATOMIC_LOAD(&irrevocable)) {
+    return stm_rollback(tx, STM_ABORT_IRREVOCABLE);
+//    return 0;
+  }
+#endif /* IRREVOCABLE_ENABLED */ 
+  /* Get commit timestamp (may exceed VERSION_MAX by up to MAX_THREADS) */
+  t = FETCH_INC_CLOCK;
+#ifdef IRREVOCABLE_ENABLED
+  if (tx->irrevocable)
+    goto release_locks;
+#endif /* IRREVOCABLE_ENABLED */
+
+  /* Try to validate (only if a concurrent transaction has committed since tx->start) */
+  if (tx->start != t - 1 && !stm_validate(tx)) {
+    /* Cannot commit */
+#if CM == CM_MODULAR
+    /* Abort caused by invisible reads */
+    tx->visible_reads++;
+#endif /* CM == CM_MODULAR */
+#ifdef INTERNAL_STATS
+    tx->aborts_validate_commit++;
+#endif /* INTERNAL_STATS */
+    return stm_rollback(tx, STM_ABORT_VALIDATE);
+    //return 0;
+  }
+
+#ifdef IRREVOCABLE_ENABLED
+  release_locks:
+#endif /* IRREVOCABLE_ENABLED */
+#if DESIGN == WRITE_THROUGH
+  /* Make sure that the updates become visible before releasing locks */
+  ATOMIC_MB_WRITE;
+  /* Drop locks and set new timestamp (traverse in reverse order) */
+  w = tx->w_set.entries + tx->w_set.nb_entries - 1;
+  for (i = tx->w_set.nb_entries; i > 0; i--, w--) {
+    if (w->no_drop)
+      continue;
+    /* No need for CAS (can only be modified by owner transaction) */
+    ATOMIC_STORE(w->lock, LOCK_SET_TIMESTAMP(t));
+  }
+  /* Make sure that all lock releases become visible */
+  ATOMIC_MB_WRITE;
+#elif DESIGN == WRITE_BACK_ETL
+  /* Install new versions, drop locks and set new timestamp */
+  w = tx->w_set.entries;
+  for (i = tx->w_set.nb_entries; i > 0; i--, w++) {
+    if (w->mask != 0) {
+      /* ACCESS CHECK */
+      if (!access_ok(VERIFY_WRITE, w->addr, sizeof(w->value)))
+        printk("%s: 1 access_ok addr %p size %d error [%d]\n",__func__, w->addr, sizeof(w->value), current->pid);
+      ATOMIC_STORE(w->addr, w->value);
+    }
+    /* Only drop lock for last covered address in write set */
+    if (w->next == NULL)
+# if CM == CM_DELAY && defined(WAIT_COND)
+			  mutex_lock(&(locks_mutex[LOCK_IDX(w->addr)]));
+			  *(w->lock) = LOCK_SET_TIMESTAMP(t);
+			  cond_broadcast(&(locks_cond[LOCK_IDX(w->addr)])); //we are not releasing but acquiring a lock
+			  mutex_unlock(&(locks_mutex[LOCK_IDX(w->addr)]));
+# else /* CM != CM_DELAY && defined(WAIT_COND) */
+			  ATOMIC_STORE_REL(w->lock, LOCK_SET_TIMESTAMP(t));
+# endif /* CM != CM_DELAY && defined(WAIT_COND) */
+  }
+#else /* DESIGN == WRITE_BACK_CTL */
+  /* Install new versions, drop locks and set new timestamp */
+  w = tx->w_set.entries;
+  for (i = tx->w_set.nb_entries; i > 0; i--, w++) {
+    if (w->mask == ~(stm_word_t)0) {
+      ATOMIC_STORE(w->addr, w->value);
+    } else if (w->mask != 0) {
+      value = (ATOMIC_LOAD(w->addr) & ~w->mask) | (w->value & w->mask);
+      ATOMIC_STORE(w->addr, w->value);
+    }
+    /* Only drop lock for last covered address in write set (cannot be "no drop") */
+    if (!w->no_drop)
+      ATOMIC_STORE_REL(w->lock, LOCK_SET_TIMESTAMP(t));
+  }
+#endif /* DESIGN == WRITE_BACK_CTL */
+
+ end:
+#if CM == CM_MODULAR || defined(INTERNAL_STATS)
+  tx->retries = 0;
+#endif /* CM == CM_MODULAR || defined(INTERNAL_STATS) */
+
+#if CM == CM_BACKOFF
+  /* Reset backoff */
+  tx->backoff = MIN_BACKOFF;
+#endif /* CM == CM_BACKOFF */
+
+#if CM == CM_MODULAR
+  tx->visible_reads = 0;
+#endif /* CM == CM_MODULAR */
+
+  /* Callbacks */
+/*  if (nb_commit_cb != 0) {
+    int cb;
+    for (cb = 0; cb < nb_commit_cb; cb++)
+      commit_cb[cb].f(TXARGS commit_cb[cb].arg);
+  }
+*/
+  mod_stats_on_commit();
+
+#ifdef IRREVOCABLE_ENABLED
+  if (tx->irrevocable) {
+    ATOMIC_STORE(&irrevocable, 0);
+    if ((tx->irrevocable & 0x08) != 0)
+      stm_quiesce_release(tx);
+  }
+#endif /* IRREVOCABLE_ENABLED */
+
+  /* Set status to COMMITTED */
+  SET_STATUS(tx->status, TX_COMMITTED);
+
+#ifdef STM_PREEMPT_AVOIDANCE
+  /* if the current transaction receives at least one bonus time slice call schedule */
+  if (tx->bonus)
+	  yield();
+#endif /* !STM_PREEMPTION_AVOIDANCE */
+
+  return SUCCESS;
+}
+// end STM_COMMIT
+
+/*
+ * Called by the CURRENT thread to abort a transaction.
+ */
+// returns ROLLBACK_ REQUESTED or NO_RETRY
+int stm_abort(TXPARAMS int reason)
+{
+  TX_GET;
+  return stm_rollback(tx, reason | STM_ABORT_EXPLICIT);
+}
+
+/*
+ * Called by the CURRENT thread to load a word-sized value.
+ */
+stm_word_t stm_load(TXPARAMS volatile stm_word_t *addr, stm_word_t * value)
+{
+  TX_GET;
+
+#ifdef IRREVOCABLE_ENABLED
+  if (unlikely(((tx->irrevocable & 0x08) != 0))) {
+    /* Serial irrevocable mode: direct access to memory */
+    return ATOMIC_LOAD(addr);
+  }
+#endif /* IRREVOCABLE_ENABLED */
+#if CM == CM_MODULAR
+  if (unlikely((tx->visible_reads >= vr_threshold && vr_threshold >= 0))) {
+    /* Use visible read */
+    return stm_read_visible(tx, addr, value);
+  }
+#endif /* CM == CM_MODULAR */
+  return stm_read_invisible(tx, addr, value);
+}
+
+/*
+ * Called by the CURRENT thread to store a word-sized value.
+ */
+int stm_store(TXPARAMS volatile stm_word_t *addr, stm_word_t value)
+{
+  TX_GET;
+
+#ifdef IRREVOCABLE_ENABLED
+  if (unlikely(((tx->irrevocable & 0x08) != 0))) {
+    /* Serial irrevocable mode: direct access to memory */
+    ATOMIC_STORE(addr, value);
+    return SUCCESS;
+  }
+#endif /* IRREVOCABLE_ENABLED */
+  return stm_write(tx, addr, value, ~(stm_word_t)0);
+}
+
+/*
+ * Called by the CURRENT thread to store part of a word-sized value.
+ */
+int stm_store2(TXPARAMS volatile stm_word_t *addr, stm_word_t value, stm_word_t mask)
+{
+  TX_GET;
+
+#ifdef IRREVOCABLE_ENABLED
+  if (unlikely(((tx->irrevocable & 0x08) != 0))) {
+    /* Serial irrevocable mode: direct access to memory */
+    if (mask == ~(stm_word_t)0)
+      ATOMIC_STORE(addr, value);
+    else
+      ATOMIC_STORE(addr, (ATOMIC_LOAD(addr) & ~mask) | (value & mask));
+    return;
+  }
+#endif /* IRREVOCABLE_ENABLED */
+  return stm_write(tx, addr, value, mask);
+}
+
+/*
+ * Called by the CURRENT thread to inquire about the status of a transaction.
+ */
+int stm_active(TXPARAM)
+{
+  TX_GET;
+
+  return IS_ACTIVE(tx->status);
+}
+
+/*
+ * Called by the CURRENT thread to inquire about the status of a transaction.
+ */
+int stm_aborted(TXPARAM)
+{
+  TX_GET;
+
+  return (GET_STATUS(tx->status) == TX_ABORTED);
+}
+
+# ifdef IRREVOCABLE_ENABLED
+/*
+ * Called by the CURRENT thread to inquire about the status of a transaction.
+ */
+int stm_irrevocable(TXPARAM)
+{
+  TX_GET;
+
+  return ((tx->irrevocable & 0x07) == 3);
+}
+# endif /* IRREVOCABLE_ENABLED */
+
+/*
+ * Called by the CURRENT thread to obtain an environment for setjmp/longjmp.
+ */
+//stm_get_env must return the snapshot id (that is what is returned by sys_)
+//the function is never used in the lib - used only for flat nesting support
+/*sigjmp_buf *stm_get_env(TXPARAM)
+{
+  TX_GET;
+
+  // Only return environment for top-level transaction
+  return tx->nesting == 0 ? &tx->env : NULL;
+}*/
+
+/*
+ * Get transaction attributes.
+ */
+// TODO TODO  TODO requires syscall level support
+/*stm_tx_attr_t *stm_get_attributes(TXPARAM)
+{
+  TX_GET;
+
+  return tx->attr;
+}*/
+
+/*
+ * Return statistics about a thread/transaction.
+ */
+int stm_get_stats(TXPARAMS const char *name, void *val)
+{
+  TX_GET;
+
+  if (strcmp("read_set_size", name) == 0) {
+    *(unsigned int *)val = tx->r_set.size;
+    return 1;
+  }
+  if (strcmp("write_set_size", name) == 0) {
+    *(unsigned int *)val = tx->w_set.size;
+    return 1;
+  }
+  if (strcmp("read_set_nb_entries", name) == 0) {
+    *(unsigned int *)val = tx->r_set.nb_entries;
+    return 1;
+  }
+  if (strcmp("write_set_nb_entries", name) == 0) {
+    *(unsigned int *)val = tx->w_set.nb_entries;
+    return 1;
+  }
+  if (strcmp("read_only", name) == 0) {
+    *(unsigned int *)val = tx->ro;
+    return 1;
+  }
+#ifdef INTERNAL_STATS
+  if (strcmp("nb_aborts", name) == 0) {
+    *(unsigned long *)val = tx->aborts;
+    return 1;
+  }
+  if (strcmp("nb_aborts_1", name) == 0) {
+    *(unsigned long *)val = tx->aborts_1;
+    return 1;
+  }
+  if (strcmp("nb_aborts_2", name) == 0) {
+    *(unsigned long *)val = tx->aborts_2;
+    return 1;
+  }
+  if (strcmp("nb_aborts_ro", name) == 0) {
+    *(unsigned long *)val = tx->aborts_ro;
+    return 1;
+  }
+  if (strcmp("nb_aborts_locked_read", name) == 0) {
+    *(unsigned long *)val = tx->aborts_locked_read;
+    return 1;
+  }
+  if (strcmp("nb_aborts_locked_write", name) == 0) {
+    *(unsigned long *)val = tx->aborts_locked_write;
+    return 1;
+  }
+  if (strcmp("nb_aborts_validate_read", name) == 0) {
+    *(unsigned long *)val = tx->aborts_validate_read;
+    return 1;
+  }
+  if (strcmp("nb_aborts_validate_write", name) == 0) {
+    *(unsigned long *)val = tx->aborts_validate_write;
+    return 1;
+  }
+  if (strcmp("nb_aborts_validate_commit", name) == 0) {
+    *(unsigned long *)val = tx->aborts_validate_commit;
+    return 1;
+  }
+  if (strcmp("nb_aborts_invalid_memory", name) == 0) {
+    *(unsigned long *)val = tx->aborts_invalid_memory;
+    return 1;
+  }
+# if CM == CM_MODULAR
+  if (strcmp("nb_aborts_killed", name) == 0) {
+    *(unsigned long *)val = tx->aborts_killed;
+    return 1;
+  }
+# endif /* CM == CM_MODULAR */
+# ifdef READ_LOCKED_DATA
+  if (strcmp("locked_reads_ok", name) == 0) {
+    *(unsigned long *)val = tx->locked_reads_ok;
+    return 1;
+  }
+  if (strcmp("locked_reads_failed", name) == 0) {
+    *(unsigned long *)val = tx->locked_reads_failed;
+    return 1;
+  }
+# endif /* READ_LOCKED_DATA */
+  if (strcmp("max_retries", name) == 0) {
+    *(unsigned long *)val = tx->max_retries;
+    return 1;
+  }
+#endif /* INTERNAL_STATS */
+  return 0;
+}
+
+/*
+ * Return STM parameters.
+ */
+int stm_get_parameter(const char *name, void *val)
+{
+  if (strcmp("contention_manager", name) == 0) {
+    *(const char **)val = cm_names[CM];
+    return 1;
+  }
+  if (strcmp("design", name) == 0) {
+    *(const char **)val = design_names[DESIGN];
+    return 1;
+  }
+  if (strcmp("initial_rw_set_size", name) == 0) {
+    *(int *)val = RW_SET_SIZE;
+    return 1;
+  }
+#if CM == CM_BACKOFF
+  if (strcmp("min_backoff", name) == 0) {
+    *(unsigned long *)val = MIN_BACKOFF;
+    return 1;
+  }
+  if (strcmp("max_backoff", name) == 0) {
+    *(unsigned long *)val = MAX_BACKOFF;
+    return 1;
+  }
+#endif /* CM == CM_BACKOFF */
+#if CM == CM_MODULAR
+  if (strcmp("vr_threshold", name) == 0) {
+    *(int *)val = vr_threshold;
+    return 1;
+  }
+#endif /* CM == CM_MODULAR */
+#ifdef COMPILE_FLAGS
+  if (strcmp("compile_flags", name) == 0) {
+    *(const char **)val = XSTR(COMPILE_FLAGS);
+    return 1;
+  }
+#endif /* COMPILE_FLAGS */
+  return 0;
+}
+
+/*
+ * Set STM parameters.
+ */
+int stm_set_parameter(const char *name, void *val)
+{
+#if CM == CM_MODULAR
+  int i;
+
+  if (strcmp("cm_policy", name) == 0) {
+    for (i = 0; cms[i].name != NULL; i++) {
+      if (strcasecmp(cms[i].name, (const char *)val) == 0) {
+        contention_manager = cms[i].f;
+        return 1;
+      }
+    }
+    return 0;
+  }
+  if (strcmp("cm_function", name) == 0) {
+    contention_manager = (int (*)(stm_tx_t *, stm_tx_t *, int))val;
+    return 1;
+  }
+  if (strcmp("vr_threshold", name) == 0) {
+    vr_threshold = *(int *)val;
+    return 1;
+  }
+#endif /* CM == CM_MODULAR */
+  return 0;
+}
+
+/*
+ * Create transaction-specific data (return -1 on error).
+ */
+int stm_create_specific(void)
+{
+  if (nb_specific >= MAX_SPECIFIC) {
+	  PRINT_ERR( "Error: maximum number of specific slots reached\n");
+    return -1;
+  }
+  return nb_specific++;
+}
+
+/*
+ * Store transaction-specific data.
+ */
+void stm_set_specific(TXPARAMS int key, void *data)
+{
+  TX_GET;
+
+  assert (key >= 0 && key < nb_specific);
+  tx->data[key] = data;
+}
+
+/*
+ * Fetch transaction-specific data.
+ */
+void *stm_get_specific(TXPARAMS int key)
+{
+  TX_GET;
+
+  assert (key >= 0 && key < nb_specific);
+  return tx->data[key];
+}
+
+/*
+ * Register callbacks for an external module (must be called before creating transactions).
+ */
+/*int stm_register(void (*on_thread_init)(TXPARAMS void *arg),
+                 void (*on_thread_exit)(TXPARAMS void *arg),
+                 void (*on_start)(TXPARAMS void *arg),
+                 void (*on_commit)(TXPARAMS void *arg),
+                 void (*on_abort)(TXPARAMS void *arg),
+                 void *arg)
+{
+  if ((on_thread_init != NULL && nb_init_cb >= MAX_CB) ||
+      (on_thread_exit != NULL && nb_exit_cb >= MAX_CB) ||
+      (on_start != NULL && nb_start_cb >= MAX_CB) ||
+      (on_commit != NULL && nb_commit_cb >= MAX_CB) ||
+      (on_abort != NULL && nb_abort_cb >= MAX_CB)) {
+	  PRINT_ERR( "Error: maximum number of modules reached\n");
+    return 0;
+  }
+  // New callback
+  if (on_thread_init != NULL) {
+    init_cb[nb_init_cb].f = on_thread_init;
+    init_cb[nb_init_cb++].arg = arg;
+  }
+  // Delete callback
+  if (on_thread_exit != NULL) {
+    exit_cb[nb_exit_cb].f = on_thread_exit;
+    exit_cb[nb_exit_cb++].arg = arg;
+  }
+  // Start callback
+  if (on_start != NULL) {
+    start_cb[nb_start_cb].f = on_start;
+    start_cb[nb_start_cb++].arg = arg;
+  }
+  // Commit callback
+  if (on_commit != NULL) {
+    commit_cb[nb_commit_cb].f = on_commit;
+    commit_cb[nb_commit_cb++].arg = arg;
+  }
+  // Abort callback
+  if (on_abort != NULL) {
+    abort_cb[nb_abort_cb].f = on_abort;
+    abort_cb[nb_abort_cb++].arg = arg;
+  }
+
+  return 1;
+}
+*/
+/*
+ * Called by the CURRENT thread to load a word-sized value in a unit transaction.
+ */
+stm_word_t stm_unit_load(volatile stm_word_t *addr, stm_word_t *timestamp)
+{
+  volatile stm_word_t *lock;
+  stm_word_t l, l2, value;
+
+  PRINT_DEBUG2("==> stm_unit_load(a=%p)\n", addr);
+
+  /* Get reference to lock */
+  lock = GET_LOCK(addr);
+
+  /* Read lock, value, lock */
+restart:
+#if CM == CM_DELAY && defined(WAIT_COND)
+  mutex_lock(&(locks_mutex[LOCK_IDX(addr)]));
+ 	  l = *lock;
+  mutex_unlock(&(locks_mutex[LOCK_IDX(addr)]));
+#else
+  l = ATOMIC_LOAD_ACQ(lock);
+#endif
+ restart_no_load:
+  if (LOCK_GET_OWNED(l)) {
+    /* Locked: wait until lock is free */
+#ifdef WAIT_YIELD
+    yield();
+#endif /* WAIT_YIELD */
+    goto restart;
+  }
+  /* Not locked */
+  value = ATOMIC_LOAD_ACQ(addr);
+#if CM == CM_DELAY && defined(WAIT_COND)
+  mutex_lock(&(locks_mutex[LOCK_IDX(addr)]));
+  	  l2 = *lock;
+  mutex_unlock(&(locks_mutex[LOCK_IDX(addr)]));
+#else /* CM != CM_DELAY && defined(WAIT_COND) */
+  l2 = ATOMIC_LOAD_ACQ(lock);
+#endif /* CM != CM_DELAY && defined(WAIT_COND) */
+  if (l != l2) {
+    l = l2;
+    goto restart_no_load;
+  }
+
+  if (timestamp != NULL)
+    *timestamp = LOCK_GET_TIMESTAMP(l);
+
+  return value;
+}
+
+/*
+ * Called by the CURRENT thread to store a word-sized value in a unit transaction.
+ */
+int stm_unit_store(volatile stm_word_t *addr, stm_word_t value, stm_word_t *timestamp)
+{
+  return stm_unit_write(addr, value, ~(stm_word_t)0, timestamp);
+}
+
+/*
+ * Called by the CURRENT thread to store part of a word-sized value in a unit transaction.
+ */
+int stm_unit_store2(volatile stm_word_t *addr, stm_word_t value, stm_word_t mask, stm_word_t *timestamp)
+{
+  return stm_unit_write(addr, value, mask, timestamp);
+}
+
+/*
+ * Enable or disable extensions and set upper bound on snapshot.
+ */
+void stm_set_extension(TXPARAMS int enable, stm_word_t *timestamp)
+{
+  TX_GET;
+
+  tx->can_extend = enable;
+  if (timestamp != NULL && *timestamp < tx->end)
+    tx->end = *timestamp;
+}
+
+/*
+ * Get current value of global clock.
+ */
+stm_word_t stm_get_clock()
+{
+  return GET_CLOCK;
+}
+
+/*
+ * Get current transaction descriptor.
+ */
+stm_tx_t *stm_current_tx()
+{
+  return stm_get_tx();
+}
+
+/* ################################################################### *
+ * UNDOCUMENTED STM FUNCTIONS (USE WITH CARE!)
+ * ################################################################### */
+
+#ifdef CONFLICT_TRACKING
+/*
+ * Get thread identifier of other transaction.
+ */
+int stm_get_thread_id(stm_tx_t *tx, pthread_t *id)
+{
+  *id = tx->thread_id;
+  return 1;
+}
+
+/*
+ * Set global conflict callback.
+ */
+int stm_set_conflict_cb(void (*on_conflict)(stm_tx_t *tx1, stm_tx_t *tx2))
+{
+  conflict_cb = on_conflict;
+  return 1;
+}
+#endif /* CONFLICT_TRACKING */
+
+#ifdef IRREVOCABLE_ENABLED
+int stm_set_irrevocable(TXPARAMS int serial)
+{
+# if CM == CM_MODULAR
+  stm_word_t t;
+# endif /* CM == CM_MODULAR */
+  TX_GET;
+
+  /* Are we already in irrevocable mode? */
+  if ((tx->irrevocable & 0x07) == 3) {
+    return 1;
+  }
+
+  if (tx->irrevocable == 0) {
+    /* Acquire irrevocability for the first time */
+    tx->irrevocable = 1 + (serial ? 0x08 : 0);
+    /* Try acquiring global lock */
+    if (irrevocable == 1
+    		|| ATOMIC_CAS_FULL(&irrevocable, 0, 1) != 0) {
+    	//|| ATOMIC_CAS_FULL(&irrevocable, 0, 1) == 0) {
+      /* Transaction will acquire irrevocability after rollback */
+      stm_rollback(tx, STM_ABORT_IRREVOCABLE);
+      return 0;
+    }
+    /* Success: remember we have the lock */
+    tx->irrevocable++;
+    /* Try validating transaction */
+    if (!stm_validate(tx)) {
+      stm_rollback(tx, STM_ABORT_VALIDATE);
+      return 0;
+    }
+# if CM == CM_MODULAR
+   /* We might still abort if we cannot set status (e.g., we are being killed) */
+    t = tx->status;
+    if (GET_STATUS(t) != TX_ACTIVE
+    		|| ATOMIC_CAS_FULL(&tx->status, t, t + (TX_IRREVOCABLE - TX_ACTIVE)) != t) {
+    	//|| (&tx->status, t, t + (TX_IRREVOCABLE - TX_ACTIVE)) == 0) {
+      stm_rollback(tx, STM_ABORT_KILLED);
+      return 0;
+    }
+# endif /* CM == CM_MODULAR */
+    if (serial && tx->w_set.nb_entries != 0) {
+      /* Don't mix transactional and direct accesses => restart with direct accesses */
+      stm_rollback(tx, STM_ABORT_IRREVOCABLE);
+      return 0;
+    }
+  } else if ((tx->irrevocable & 0x07) == 1) {
+    /* Acquire irrevocability after restart (no need to validate) */
+    while (irrevocable == 1
+    		|| ATOMIC_CAS_FULL(&irrevocable, 0, 1) != 0)
+    		//|| ATOMIC_CAS_FULL(&irrevocable, 0, 1) == 0)
+      ;
+    /* Success: remember we have the lock */
+    tx->irrevocable++;
+  }
+  assert((tx->irrevocable & 0x07) == 2);
+
+  /* Are we in serial irrevocable mode? */
+  if ((tx->irrevocable & 0x08) != 0) {
+    /* Stop all other threads */
+    if (stm_quiesce(tx, 1) != 0) {
+      /* Another thread is quiescing and we are active (trying to acquire irrevocability) */
+      assert(serial != -1);
+      stm_rollback(tx, STM_ABORT_IRREVOCABLE);
+      return 0;
+    }
+  }
+
+  /* We are in irrevocable mode */
+  tx->irrevocable++;
+
+  return 1;
+}
+#else /* ! IRREVOCABLE_ENABLED */
+int stm_set_irrevocable(TXPARAMS int serial)
+{
+	PRINT_ERR("Irrevocability is not supported in this configuration\n");
+//  exit(-1);
+  return 1;
+}
+#endif /* ! IRREVOCABLE_ENABLED */
